Package: LymphoSeq
Title: Analyze high-throughput sequencing of T and B cell receptors
Version: 1.39.0
Author: David Coffey <dcoffey@fredhutch.org>
Maintainer: David Coffey <dcoffey@fredhutch.org>
Description: This R package analyzes high-throughput sequencing of T
        and B cell receptor complementarity determining region 3 (CDR3)
        sequences generated by Adaptive Biotechnologies' ImmunoSEQ
        assay.  Its input comes from tab-separated value (.tsv) files
        exported from the ImmunoSEQ analyzer.
Depends: R (>= 3.3), LymphoSeqDB
Imports: data.table, plyr, dplyr, reshape, VennDiagram, ggplot2, ineq,
        RColorBrewer, circlize, grid, utils, stats, ggtree, msa,
        Biostrings, phangorn, stringdist, UpSetR
License: Artistic-2.0
RoxygenNote: 6.0.1
Suggests: knitr, pheatmap, wordcloud, rmarkdown
VignetteBuilder: knitr
biocViews: Software, Technology, Sequencing, TargetedResequencing,
        Alignment, MultipleSequenceAlignment
NeedsCompilation: no
git_url: https://git.bioconductor.org/packages/LymphoSeq
git_branch: devel
git_last_commit: be99fc7
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-31
Packaged: 2025-10-31 22:33:24 UTC; biocbuild

# LymphoSeq
This R package analyzes high-throughput sequencing of T and B cell receptor
complementarity determining region 3 (CDR3) sequences generated by [Adaptive
Biotechnologies' ImmunoSEQ assay](http://www.adaptivebiotech.com/immunoseq).

### Installation instructions

#### Install release version 1.4
###### Install from [Bioconductor](https://www.bioconductor.org/packages/LymphoSeq)
```
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("LymphoSeq")
```

#### Install developer version 1.5
###### Option 1:  Install from [Bioconductor developer branch](https://www.bioconductor.org/developers/how-to/useDevel/)
```
# Switch to Bioconductor developer branch (requires latest version of R)
library(BiocManager)
BiocManager::install(version = "devel")

# Download developer release
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("LymphoSeq")
```
###### Option 2:  Install from GitHub
```
# Install the latest version of Bioconductor
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install()

# Download developer tools
install.packages("devtools")

# Download package from GitHub
devtools::install_github("davidcoffey/LymphoSeqDB")
devtools::install_github("davidcoffey/LymphoSeq")
```

### Documentation
* [LymphoSeq vignette](http://bioconductor.org/packages/release/bioc/vignettes/LymphoSeq/inst/doc/LymphoSeq.html)
* [LymphoSeq manual](https://bioconductor.org/packages/release/bioc/manuals/LymphoSeq/man/LymphoSeq.pdf)
* [LymphoSeq news](https://bioconductor.org/packages/release/bioc/news/LymphoSeq/NEWS)

### Citation
Coffey D (2017). LymphoSeq: Analyze high-throughput sequencing of T and B cell receptors. R package version 1.4.

#' Clone tracking plot
#' 
#' Creates line plot tracking amino acid frequencies across multiple samples
#' 
#' @param sequence.matrix A sequence matrix generated from the LymphoSeq 
#' function seqMatrix.
#' @param map An optional character vector of one or more sample names contained 
#' in the productive.aa list.  If the same sequence appears in multiple mapped 
#' samples, then it will be assigned the label of the first listed sample only.
#' @param productive.aa A list of data frames of productive amino acid sequences 
#' containing the samples to be mapped.  This parameter is only required if 
#' sequence mapping is performed.
#' @param label An optional character vector of one or more labels used to 
#' annotate the mapped sequences.  The order of the labels must match the order 
#' of the samples listed in map.
#' @param track An optional character vector of one or more amino acid sequences 
#' to track.
#' @param unassigned A Boolean value indicating whether or not to draw the lines 
#' of sequences not being mapped or tracked.  If TRUE then the unassigned 
#' sequences are drawn.  If FALSE, then the unassigned sequences are not drawn.
#' @return Returns a line plot showing the amino acid frequencies across 
#' multiple samples in the sequence matrix where each line represents one 
#' unique sequence.
#' @details The plot is made using the package ggplot2 and can be reformatted
#' using ggplot2 functions.  See examples below.
#' @seealso An excellent resource for examples on how to reformat a ggplot can 
#' be found in the R Graphics Cookbook online (\url{http://www.cookbook-r.com/Graphs/}).
#' @examples
#' file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")
#' 
#' file.list <- readImmunoSeq(path = file.path)
#' 
#' productive.aa <- productiveSeq(file.list = file.list, aggregate = "aminoAcid")
#' 
#' top.freq <- topFreq(productive.aa = productive.aa, percent = 0.1)
#' 
#' sequence.matrix <- seqMatrix(productive.aa = productive.aa, sequences = top.freq$aminoAcid)
#' 
#' # Track clones without mapping or tracking specific sequences
#' cloneTrack(sequence.matrix = sequence.matrix)
#' 
#' # Track top 20 clones mapping to the CD4 and CD8 samples
#' cloneTrack(sequence.matrix = sequence.matrix, productive.aa = productive.aa, 
#'    map = c("TRB_CD4_949", "TRB_CD8_949"), label = c("CD4", "CD8"), 
#'    track = top.freq$aminoAcid[1:20], unassigned = TRUE) 
#' 
#' # Track the top 10 clones from top.freq
#' cloneTrack(sequence.matrix = sequence.matrix, productive.aa = productive.aa, 
#'    track = top.freq$aminoAcid[1:10], unassigned = FALSE) 
#' 
#' # Track clones mapping to the CD4 and CD8 samples while ignoring all others
#' cloneTrack(sequence.matrix = sequence.matrix, productive.aa = productive.aa, 
#'    map = c("TRB_CD4_949", "TRB_CD8_949"), label = c("CD4", "CD8"), 
#'    unassigned = FALSE) 
#' 
#' # Track clones mapping to the CD4 and CD8 samples and track 2 specific sequences
#' cloneTrack(sequence.matrix = sequence.matrix, productive.aa = productive.aa, 
#'    map = c("TRB_CD4_949", "TRB_CD8_949"), label = c("CD4", "CD8"), 
#'    track = c("CASSPPTGERDTQYF", "CASSQDRTGQYGYTF"), unassigned = FALSE)
#' 
#' # Reorder the x axis, change the axis labels, convert to log scale, and add title
#' x.limits <- c("TRB_Unsorted_0", "TRB_Unsorted_32", 
#'    "TRB_Unsorted_83", "TRB_Unsorted_949", "TRB_Unsorted_1320")
#' 
#' sequence.matrix <- sequence.matrix[ ,c("aminoAcid", x.limits)]
#'    
#' clone.track <- cloneTrack(sequence.matrix = sequence.matrix, 
#'    productive.aa = productive.aa, track = top.freq$aminoAcid[1:10], unassigned = FALSE) 
#' 
#' x.labels <- c("Day 0", "Day 32", "Day 83", "Day 949", "Day 1320")
#' 
#' clone.track + 
#'    ggplot2::scale_x_discrete(expand = c(0,0), labels = x.labels) + 
#'    ggplot2::scale_y_log10() + ggplot2::annotation_logticks(sides = "l") + 
#'    ggplot2::ggtitle("Figure Title")
#' @export
#' @import ggplot2
#' @importFrom RColorBrewer brewer.pal
#' @importFrom reshape melt.data.frame
cloneTrack <- function(sequence.matrix, map = "none", productive.aa, 
                       label = "none", track = "none", unassigned = TRUE) {
    if (any(map != "none")) {
        sequence.matrix$numberSamples <- NULL
        sequence.melt <- reshape::melt.data.frame(sequence.matrix, 
                                                  id.vars = "aminoAcid")
        names(sequence.melt) <- c("aminoAcid", "Sample", "Frequency")
        sequence.melt$Map <- rep("Unassigned", length(sequence.matrix$aminoAcid))
        if (any(track != "none")) {
            i <- 1
            for (i in 1:length(track)) {
                sequence.melt$Map <- ifelse(sequence.melt$aminoAcid == track[i], 
                                            track[i], sequence.melt$Map)
            }
        }
        j <- 1
        for (j in 1:length(map)) {
            file <- productive.aa[[map[j]]]
            aminoAcid <- as.character(file$aminoAcid)
            sequence.melt$Map <- ifelse(sequence.melt$aminoAcid %in% aminoAcid & 
                                            sequence.melt$Map == "Unassigned", 
                                        label[j], sequence.melt$Map)
        }
        if (unassigned == FALSE) {
            sequence.melt <- sequence.melt[sequence.melt$Map != "Unassigned", ]
        }
        getPalette <- grDevices::colorRampPalette(RColorBrewer::brewer.pal(9, "Set1"))
        plot <- ggplot2::ggplot(sequence.melt, 
                                aes_string(x = "Sample", 
                                           y = "Frequency", 
                                           group = "aminoAcid", 
                                           color = "Map")) + 
            geom_line() + 
            theme_minimal() + 
            scale_x_discrete(expand = c(0, 0)) + 
            scale_y_continuous(expand = c(0, 0)) + 
            labs(x = "", y = "Frequency (%)", color = "") + 
            scale_colour_manual(values = c(getPalette(length(label) + 
                                                          length(track) + 1))) + 
            theme(axis.text.x = element_text(angle = 90, vjust = 0.5, hjust = 1))
        return(plot)
    } else {
        sequence.matrix$numberSamples <- NULL
        sequence.melt <- reshape::melt.data.frame(sequence.matrix, id.vars = "aminoAcid")
        names(sequence.melt) <- c("aminoAcid", "Sample", "Frequency")
        if (any(track != "none")) {
            sequence.melt$Map <- rep("Unassigned", length(sequence.matrix$aminoAcid))
            k <- 1
            for (k in 1:length(track)) {
                sequence.melt$Map <- ifelse(sequence.melt$aminoAcid == track[k], 
                                            track[k], sequence.melt$Map)
            }
            if (unassigned == FALSE) {
                sequence.melt <- sequence.melt[sequence.melt$Map != "Unassigned", 
                                               ]
            }
            getPalette <- grDevices::colorRampPalette(RColorBrewer::brewer.pal(9, "Set1"))
            plot <- ggplot2::ggplot(sequence.melt, aes_string(x = "Sample", 
                                                              y = "Frequency", 
                                                              group = "aminoAcid", 
                                                              color = "Map")) + 
                geom_line() + theme_minimal() + 
                scale_x_discrete(expand = c(0,0)) + 
                scale_y_continuous(expand = c(0, 0)) + 
                labs(x = "", y = "Frequency (%)", color = "") + 
                scale_colour_manual(values = getPalette(length(track) + 1)) + 
                theme(axis.text.x = element_text(angle = 90, vjust = 0.5, hjust = 1))
            return(plot)
        }
        plot <- ggplot2::ggplot(sequence.melt, aes_string(x = "Sample", 
                                                          y = "Frequency", 
                                                          group = "aminoAcid")) + 
            geom_line() + 
            theme_minimal() + 
            scale_x_discrete(expand = c(0, 0)) + 
            scale_y_continuous(expand = c(0, 0)) + 
            labs(x = "", y = "Frequency (%)") + 
            theme(axis.text.x = element_text(angle = 90, vjust = 0.5, hjust = 1))
        return(plot)
    }
} 

#' Gene frequencies
#' 
#' Creates a data frame of VDJ gene counts and frequencies.
#' 
#' @param productive.nt A list of one or more data frames of productive sequences 
#' generated by the LymphoSeq function productiveSeq where the parameter 
#' aggregate is set to "nucleotide".
#' @param locus A character vector indicating which VDJ genes to include in the 
#' output.  Available options include "VDJ", "DJ", "VJ", "DJ", "V", "D", or "J".
#' @param family A Boolean value indicating whether or not family names instead 
#' of gene names are used.  If TRUE, then family names are used and if FALSE, 
#' gene names are used.
#' @return Returns a data frame with the sample names, VDJ gene name, count, and 
#' \% frequency of the V, D, or J genes (each gene frequency should add to 
#' 100\% for each sample).
#' @examples
#' file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")
#' 
#' file.list <- readImmunoSeq(path = file.path)
#' 
#' productive.nt <- productiveSeq(file.list = file.list, aggregate = "nucleotide")
#' 
#' geneFreq(productive.nt, locus = "VDJ", family = FALSE)
#' 
#' # Create a heat map of V gene usage
#' vfamilies <- geneFreq(productive.nt, locus = "V", family = TRUE)
#' 
#' require(reshape)
#' 
#' vfamilies <- reshape::cast(vfamilies, familyName ~ samples, value = "frequencyGene", sum)
#' 
#' rownames(vfamilies) <- as.character(vfamilies$familyName)
#' 
#' vfamilies$familyName <- NULL
#' 
#' RedBlue <- grDevices::colorRampPalette(rev(RColorBrewer::brewer.pal(11, "RdBu")))(256)
#' 
#' require(pheatmap)
#' 
#' pheatmap::pheatmap(vfamilies, color = RedBlue, scale = "row")
#' 
#' # Create a word cloud of V gene usage
#' vgenes <- geneFreq(productive.nt, locus = "V", family = FALSE)
#' 
#' require(wordcloud)
#' 
#' wordcloud::wordcloud(words = vgenes[vgenes$samples == "TRB_Unsorted_83", "geneName"], 
#'    freq = vgenes[vgenes$samples == "TRB_Unsorted_83", "frequencyGene"], 
#' 	  colors = RedBlue)
#' 
#' # Create a cumulative frequency bar plot of V gene usage
#' vgenes <- geneFreq(productive.nt, locus = "V", family = FALSE)
#' 
#' require(ggplot2)
#' 
#' ggplot2::ggplot(vgenes, aes(x = samples, y = frequencyGene, fill = geneName)) +
#'   geom_bar(stat = "identity") +
#'   theme_minimal() + 
#'   scale_y_continuous(expand = c(0, 0)) + 
#'   guides(fill = guide_legend(ncol = 3)) +
#'   labs(y = "Frequency (%)", x = "", fill = "") +
#'   theme(axis.text.x = element_text(angle = 90, vjust = 0.5, hjust = 1))
#' @export
#' @importFrom stats aggregate
geneFreq <- function(productive.nt, locus = "VDJ", family = FALSE) {
    gene.names <- data.frame()
    if (family == FALSE) {
        i <- 1
        for (i in 1:length(productive.nt)) {
            file <- productive.nt[[i]]
            file[file == ""] <- "unresolved"
            name <- names(productive.nt)
            v <- data.frame()
            d <- data.frame()
            j <- data.frame()
            if (grepl("V|v", locus)) {
                v <- aggregate(count ~ vGeneName, data = file, FUN = sum)
                v <- data.frame(samples = name[i], geneName = v$vGeneName, 
                                count = v$count, 
                                frequencyGene = v$count/sum(v$count) * 100)
            }
            if (grepl("D|d", locus)) {
                d <- aggregate(count ~ dGeneName, data = file, FUN = sum)
                d <- data.frame(samples = name[i], geneName = d$dGeneName, 
                                count = d$count, 
                                frequencyGene = d$count/sum(d$count) * 100)
            }
            if (grepl("J|j", locus)) {
                j <- aggregate(count ~ jGeneName, data = file, FUN = sum)
                j <- data.frame(samples = name[i], geneName = j$jGeneName, 
                                count = j$count, 
                                frequencyGene = j$count/sum(j$count) * 100)
            }
            gene.names <- rbind(v, d, j, gene.names)
        }
    } else {
        i <- 1
        for (i in 1:length(productive.nt)) {
            file <- productive.nt[[i]]
            file[file == ""] <- "unresolved"
            name <- names(productive.nt)
            v <- data.frame()
            d <- data.frame()
            j <- data.frame()
            if (grepl("V|v", locus)) {
                v <- aggregate(count ~ vFamilyName, data = file, FUN = sum)
                v <- data.frame(samples = name[i], familyName = v$vFamilyName, 
                                count = v$count, 
                                frequencyGene = v$count/sum(v$count) * 100)
            }
            if (grepl("D|d", locus)) {
                d <- aggregate(count ~ dFamilyName, data = file, FUN = sum)
                d <- data.frame(samples = name[i], familyName = d$dFamilyName, 
                                count = d$count, 
                                frequencyGene = d$count/sum(d$count) * 100)
            }
            if (grepl("J|j", locus)) {
                j <- aggregate(count ~ jFamilyName, data = file, FUN = sum)
                j <- data.frame(samples = name[i], familyName = j$jFamilyName, 
                                count = j$count, 
                                frequencyGene = j$count/sum(j$count) * 100)
            }
            gene.names <- rbind(v, d, j, gene.names)
        }
    }
    return(gene.names)
}

#' Differential abundance analysis
#' 
#' Use a Fisher exact test to calculate differential abdunance of each sequence in 
#' two samples and reports the log2 transformed fold change, P value and adjusted P value.
#' 
#' @param list A list of data frames consisting of antigen receptor sequences 
#' imported by the LymphoSeq function readImmunoSeq.
#' @param sample1 A character vector indicating the name of the first sample in the list
#' to be compared.
#' @param sample2 A character vector indicating the name of the second sample in the list
#' to be compared.
#' @param type A character vector indicating whether "aminoAcid" or "nucleotide" sequences
#' should be used.  If "aminoAcid" is specified, then run productiveSeqs first.
#' @param q A numeric value between 0.0 and 1.0 indicating the threshold Holms adjusted 
#' P value (also knowns as the false discovery rate or q value) to subset the results with.  
#' Any sequences with a q value greater than this value will not be shown.
#' @param zero A numeric value to set all zero values to when calculating the log2
#' transformed fold change between samples 1 and 2.  This does not apply to the 
#' p and q value calculations.
#' @param abundance The input value for the Fisher exact test.  "estimatedNumberGenomes"
#' is recommend but "count" may also be used.
#' @param parallel A boolean indicating wheter parallel processing should be used or not.
#' @return Returns a data frame with columns corresponding to the frequency of the abudance
#' measure in samples 1 and 2, the P value, Q value (Holms adjusted P value, also knowns as 
#' the false discovery rate), and log2 transformed fold change.
#' @examples
#' file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")
#' 
#' file.list <- readImmunoSeq(path = file.path)
#' 
#' productive.aa <- productiveSeq(file.list = file.list, aggregate = "aminoAcid")
#' 
#' differentialAbundance(list = productive.aa, sample1 = "TRB_Unsorted_949", 
#'                       sample2 = "TRB_Unsorted_1320", type = "aminoAcid", q = 0.01, 
#'                       zero = 0.001)
#' @export
#' @importFrom stats p.adjust
#' @importFrom stats fisher.test
differentialAbundance <- function(sample1, sample2, list, abundance = "estimatedNumberGenomes", 
                                  type = "aminoAcid", q = 1, zero = 0.001, parallel = FALSE) {
    x <- list[[sample1]]
    y <- list[[sample2]]
    sequences <- union(x[, type], y[, type])
    fisherFunction <- function(sequences) {
        p.value <- as.numeric()
        sample1.freq <- as.numeric()
        sample2.freq <- as.numeric()
        if (any(x[, type] == sequences)) {
            in.x <- x[x[, type] == sequences, abundance]
            x.freq <- x[x[, type] == sequences, abundance]/sum(x[, abundance]) * 
                100
        } else {
            in.x <- 0
            x.freq <- 0
        }
        if (any(y[, type] == sequences)) {
            in.y <- y[y[, type] == sequences, abundance]
            y.freq <- y[y[, type] == sequences, abundance]/sum(y[, abundance]) * 
                100
        } else {
            in.y <- 0
            y.freq <- 0
        }
        not.x <- sum(x[, abundance]) - in.x
        not.y <- sum(y[, abundance]) - in.y
        matrix <- matrix(c(in.x, in.y, not.x, not.y), nrow = 2)
        fisher <- stats::fisher.test(matrix, workspace = 2e6)
        p.value <- c(p.value, fisher$p.value)
        sample1.freq <- c(sample1.freq, x.freq)
        sample2.freq <- c(sample2.freq, y.freq)
        results <- data.frame(aminoAcid = sequences, 
                              x = sample1.freq, 
                              y = sample2.freq, 
                              p = p.value)
        return(results)
    }
    #doMC::registerDoMC(cores = cores)
    results <- plyr::ldply(sequences, fisherFunction, .parallel = parallel)
    results$q <- stats::p.adjust(results$p, method = "holm")
    x.not.zero <- results[, "x"]
    x.not.zero[x.not.zero == 0] <- zero
    y.not.zero <- results[, "y"]
    y.not.zero[y.not.zero == 0] <- zero
    results$l2fc <- log2(x.not.zero/y.not.zero)
    names(results)[2] <- sample1
    names(results)[3] <- sample2
    results <- results[order(results$q, decreasing = FALSE), ]
    results <- results[results$q <= q, ]
    rownames(results) <- NULL
    return(results)
}

#' Clonal relatedness
#' 
#' Calculates the clonal relatedness for each sample in a list of data frames.
#' 
#' @param list A list data frames of unproductive or productive nucleotide 
#' sequences or productive nucleotide sequences.  Nucleotide and count are 
#' required columns.
#' @param editDistance An integer giving the minimum edit distance that the 
#' sequence must be less than or equal to. See details below.
#' @details  Clonal relatedness is the proportion of nucleotide sequences that
#' are related by a defined edit distance threshold.  The value ranges from 0 to
#' 1 where 0 indicates no sequences are related and 1 indicates all sequences 
#' are related.
#' 
#' Edit distance is a way of quantifying how dissimilar two sequences 
#' are to one another by counting the minimum number of operations required to 
#' transform one sequence into the other. For example, an edit distance of 0 
#' means the sequences are identical and an edit distance of 1 indicates that 
#' the sequences different by a single amino acid or nucleotide.
#' @return Returns a data frame with the calculated clonal relatedness for each sample.
#' @examples
#' file.path <- system.file("extdata", "IGH_sequencing", package = "LymphoSeq")
#' 
#' file.list <- readImmunoSeq(path = file.path)
#' 
#' clonal.relatedness <- clonalRelatedness(list = file.list, editDistance = 10)
#' 
#' # Merge results with clonality table
#' clonality <- clonality(file.list = file.list)
#' merged <- merge(clonality, clonal.relatedness)
#' 
#' @export
#' @importFrom stringdist stringdist
clonalRelatedness <- function(list, editDistance = 10){
    relatedness <- as.numeric()
    clonality <- as.numeric()
    cloneResolved <- as.character()
    i <- 2
    for(i in 1:length(list)){
        file <- list[[i]]
        top <- file[order(file$count, decreasing = TRUE), "nucleotide"][1]
        result1 <- length(which(
            stringdist::stringdist(top, file$nucleotide, 
                                   method = "lv") < editDistance))/nrow(file)
        relatedness <- c(relatedness, result1)
    }
    df <- data.frame(samples = names(list), clonalRelatedness = relatedness)
    return(df)
}

#' Common sequences in two or more samples
#' 
#' Creates a data frame of the common sequences in two or more samples, reporting 
#' their frequencies in each.
#' 
#' @param samples A character vector of two or more sample names in 
#' productive.aa.
#' @param productive.aa A list of productive amino acid sequences generated
#' by the LymphoSeq function productiveSeq where aggregate = "aminoAcid".
#' @return Returns a data frame of the common sequences between two or more files 
#' displaying their frequencies in each.
#' @seealso \code{\link{commonSeqsVenn}}
#' @examples
#' file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")
#' 
#' file.list <- readImmunoSeq(path = file.path)
#' 
#' productive.aa <- productiveSeq(file.list = file.list, aggregate = "aminoAcid")
#' 
#' commonSeqs(samples = c("TRB_Unsorted_0", "TRB_Unsorted_32"), 
#'    productive.aa = productive.aa)
#' @export
#' @importFrom plyr llply
#' @import ggplot2
commonSeqs <- function(samples, productive.aa) {
    aminoAcid <- plyr::llply(productive.aa[samples], 
                             function(x) x[, "aminoAcid"])
    common <- Reduce(intersect, aminoAcid)
    seq.matrix <- seqMatrix(productive.aa[samples], common)
    seq.matrix$numberSamples <- NULL
    return(seq.matrix)
}

#' Top sequences
#' 
#' Creates a data frame of a selected number of top productive sequences 
#' from a list of data frames.
#' 
#' @param productive.seqs A list data frames of productive sequences generated 
#' by the LymphoSeq function productiveSeq.  "frequencyCount" and "aminoAcid" 
#' are a required columns.
#' @param top The number of top productive sequences in each data frame to subset 
#' by their frequencies.
#' @return Returns a data frame of a selected number of top productive sequences 
#' from a list of data frames.
#' @seealso \code{\link{chordDiagramVDJ}}
#' @examples
#' file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")
#' 
#' file.list <- readImmunoSeq(path = file.path)
#' 
#' productive.aa <- productiveSeq(file.list = file.list, aggregate = "aminoAcid")
#' 
#' top.seqs <- topSeqs(productive.seqs = productive.aa, top = 1)
#' @export
#' @importFrom plyr llply ldply
topSeqs <- function(productive.seqs, top = 1) {
    top.seqs <- plyr::llply(productive.seqs, function(x) 
        x[order(x$frequencyCount, decreasing = TRUE), ])
    top.seqs <- plyr::llply(productive.seqs, function(x) x[1:top, ])
    top.seqs <- plyr::ldply(top.seqs, data.frame)
    colnames(top.seqs)[1] <- "samples"
    return(top.seqs)
} 

#' Search for a sequence
#' 
#' Search for one or more amino acid or nucleotide CDR3 sequences in a list of 
#' data frames.
#' 
#' @param list A list of data frames generated by the LymphoSeq functions readImmunoSeq 
#' or productiveSeq.  "aminoAcid" or "nucleotide", "frequencyCount", and 
#' "count" are required columns.
#' @param sequence A character vector of one ore more amino acid or nucleotide 
#' CDR3 sequences to search.
#' @param type A character vector specifying the type of sequence(s) to be 
#' searched.  Available options are "aminoAcid" or "nucleotide". 
#' @param match A character vector specifying whether an exact partial or exact global
#'  match of the searched sequence(s) is desired.  Available options are 
#' "partial" and "global".
#' @param editDistance An integer giving the minimum edit distance that the 
#' sequence must be less than or equal to.  See details below.
#' @details An exact partial match means the searched sequence is contained within 
#' target sequence.  An exact global match means the searched sequence is identical to 
#' the target sequence.
#' 
#' Edit distance is a way of quantifying how dissimilar two sequences 
#' are to one another by counting the minimum number of operations required to 
#' transform one sequence into the other.  For example, an edit distance of 0 
#' means the sequences are identical and an edit distance of 1 indicates that 
#' the sequences different by a single amino acid or nucleotide.
#' @return Returns the rows for every instance in the list of data frames where 
#' the searched sequence(s) appeared.
#' @examples
#' file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")
#' 
#' file.list <- readImmunoSeq(path = file.path)
#' 
#' aa1 <- "CASSPVSNEQFF"
#' 
#' aa2 <- "CASSQEVPPYQAFF"
#' 
#' searchSeq(list = file.list, sequence = aa1, type = "aminoAcid", 
#'    match = "global", editDistance = 0)
#' 
#' searchSeq(list = file.list, sequence = c(aa1, aa2), 
#'    type = "aminoAcid", match = "global", editDistance = 0)
#' 
#' searchSeq(list = file.list, sequence = aa1, type = "aminoAcid", editDistance = 1)
#' 
#' nt <- "CTGATTCTGGAGTCCGCCAGCACCAACCAGACATCTATGTACCTCTGTGCCAGCAGTCCGGTAAGCAATGAGCAGTTCTTCGGGCCA"
#' 
#' searchSeq(list = file.list, sequence = nt, type = "nucleotide", editDistance = 3)
#' 
#' searchSeq(list = file.list, sequence = "CASSPVS", type = "aminoAcid", 
#'    match = "partial", editDistance = 0)
#' 
#' searchSeq(list = file.list, sequence = nt, type = "nucleotide", editDistance = 0)
#' @export
#' @importFrom plyr llply
#' @importFrom utils adist
searchSeq <- function(list, sequence, type = "aminoAcid", match = "global", editDistance = 0) {
    if (editDistance >= 1) {
        merged.results <- data.frame()
        i <- 1
        for (i in 1:length(list)) {
            file <- list[[i]]
            ed <- adist(sequence, file[, type])
            rownames(ed) <- sequence
            colnames(ed) <- file[, type]
            ed.index <- which(ed <= editDistance, arr.ind = TRUE)
            if (nrow(ed.index) >= 1) {
                ed.subset <- as.integer()
                j <- 1
                for (j in 1:nrow(ed.index)) {
                    ed.j <- ed[ed.index[j, "row"], ed.index[j, "col"]]
                    ed.subset <- c(ed.subset, ed.j)
                }
                results <- data.frame(searchSequnece = rownames(ed)[ed.index[, 1]], 
                                      foundSequnece = colnames(ed)[ed.index[, 2]], 
                                      editDistance = ed.subset)
                results <- results[!duplicated(results), ]
                search <- plyr::llply(list[i], function(x) 
                    x[which(x[, type] %in% results$foundSequnece), ])
                found <- NULL
                k <- 1
                for (k in 1:length(search)) {
                    if (nrow(search[[k]]) != 0) {
                        search[[k]] <- cbind(rep(names(search)[k], nrow(search[[k]])), 
                                             search[[k]])
                        colnames(search[[k]])[1] <- "sample"
                        found <- rbind(found, search[[k]])
                    }
                }
                names(found)[which(names(found) == type)] <- "foundSequnece"
                merged.search <- merge(results, found)
                merged.results <- rbind(merged.results, merged.search)
                merged.results <- merged.results[c("sample", setdiff(names(merged.results), "sample"))]
            }
        }
        if (nrow(merged.results) >= 1) {
            merged.results$foundSequnece = as.character(merged.results$foundSequnece)
            merged.results$searchSequnece = as.character(merged.results$searchSequnece)
            merged.results = merged.results[order(merged.results$frequencyCount, decreasing = TRUE),]
            rownames(merged.results) = NULL
            return(merged.results)
        } else {
            cat("No sequences found.")
        }
    } else {
        if (match == "global") {
            search <- plyr::llply(list, function(x) 
                x[which(x[, type] %in% sequence), ])
        }
        if (match == "partial") {
            search <- plyr::llply(list, function(x) 
                x[grep(paste(sequence, collapse = "|"), x[, type]), ])
        }
        found <- NULL
        l <- 1
        for (l in 1:length(search)) {
            if (nrow(search[[l]]) != 0) {
                search[[l]] <- cbind(rep(names(search)[l], nrow(search[[l]])), search[[l]])
                colnames(search[[l]])[1] <- "sample"
                found <- rbind(found, search[[l]])
            }
        }
        if (is.null(found)) {
            message("No sequences found.")
        } else {
            found = found[order(found$frequencyCount, decreasing = TRUE),]
            rownames(found) = NULL
            return(found)
        }
    }
}

#' Export sequences in fasta format
#' 
#' Export nucleotide or amino acid sequences in fasta format.
#' 
#' @param list A list of data frames consisting of antigen receptor sequences 
#' imported by the LymphoSeq function readImmunoSeq.
#' @param type A character vector indicating whether "aminoAcid" or "nucleotide" sequences
#' should be exported.  If "aminoAcid" is specified, then run productiveSeqs first.
#' @param names A character vector of one or more column names to name the sequences.
#' If "rank" is specified, then the rank order of the sequences by frequency is used.
#' @return Exports fasta files to the working directory.
#' @examples
#' file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")
#' 
#' file.list <- readImmunoSeq(path = file.path)
#' 
#' exportFasta(list = file.list, type = "nucleotide", names = c("rank", "aminoAcid", "count"))
#' 
#' productive.aa <- productiveSeq(file.list = file.list, aggregate = "aminoAcid")
#' 
#' exportFasta(list = productive.aa, type = "aminoAcid", names = "frequencyCount")
#' @export
#' @importFrom Biostrings DNAStringSet
#' @importFrom Biostrings AAStringSet
#' @importFrom Biostrings writeXStringSet
exportFasta <- function(list, type = "nucleotide", names = c("rank", "aminoAcid", "count")) {
    if (type == "nucleotide") {
        i <- 1
        for (i in 1:length(list)) {
            file <- list[[i]]
            sequences <- file$nucleotide
            fasta <- Biostrings::DNAStringSet(sequences)
            if (any(names %in% "rank")) {
                file$rank <- rownames(file)
            }
            names(fasta) <- do.call(paste, c(file[names], sep = "_"))
            Biostrings::writeXStringSet(fasta, paste(names(list[i]), ".fasta", sep = ""))
        }
    }
    if (type == "aminoAcid") {
        i <- 1
        for (i in 1:length(list)) {
            file <- list[[i]]
            sequences <- file$aminoAcid
            if (any(sequences == "") | any(grepl("\\*", sequences))) {
                stop("Your list contains unproductive sequences.  Remove unproductive sequences first using the function productiveSeq.", call. = FALSE)
            }
            fasta <- Biostrings::AAStringSet(sequences)
            if (any(names %in% "rank")) {
                file$rank <- rownames(file)
            }
            names(fasta) <- do.call(paste, c(file[names], sep = "_"))
            Biostrings::writeXStringSet(fasta, paste(names(list[i]), ".fasta", sep = ""))
        }
    }
    message(paste("Fasta files saved to", getwd()))
}

#' Common sequences bar plot
#' 
#' Creates an UpSetR bar plot showing the number of intersecting sequences across 
#' multiple samples.  This function is useful when more than 3 samples are being 
#' compared.
#' 
#' @param productive.aa A list data frames of of productive amino acid sequences 
#' generated by LymphoSeq function productiveSeq where the aggregate parameter 
#' was set to "aminoAcid".
#' @param samples The names of two or more samples in the productive.aa 
#' list whose intersections will shown.
#' @param color.sample The name of a single sample in the productive.aa list whose 
#' sequences will be colored in all samples that they appear in.
#' @param color.intersection The names of two or more samples in the productive.aa 
#' list whose intersections will be colored.
#' @param color A character vector of a color name that will be used highlight a selected 
#' sample or multiple sample intersections.
#' @param labels A character vector indicating whether the number of 
#' intersecting sequences should be shown on the tops of the bars.  Options 
#' include "yes" or "no".
#' @return Returns an UpSetR bar plot showing the number of intersecting sequences 
#' across multiple samples.
#' @examples
#' file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")
#' 
#' file.list <- readImmunoSeq(path = file.path)
#' 
#' productive.aa <- productiveSeq(file.list = file.list, aggregate = "aminoAcid")
#' 
#' commonSeqsBar(productive.aa = productive.aa, samples = c("TRB_CD4_949", "TRB_CD8_949", 
#' "TRB_Unsorted_949", "TRB_Unsorted_1320"), color.sample = "TRB_CD8_949")
#' @export
#' @import UpSetR
commonSeqsBar = function(productive.aa, samples, color.sample = NULL , 
                         color.intersection = NULL, color = "#377eb8", labels = "no"){
    unique.seqs = uniqueSeqs(productive.aa = productive.aa)
    sequence.matrix = seqMatrix(productive.aa = productive.aa, sequences = unique.seqs$aminoAcid)
    aminoAcid = sequence.matrix$aminoAcid
    sequence.matrix = sequence.matrix[,-c(1:2)]
    sequence.matrix[sequence.matrix > 0] <- 1
    sequence.matrix = cbind(aminoAcid, sequence.matrix)
    
    if(!is.null(color.sample)){
        queryFunction = function(row, sequence) {
            data <- (row["aminoAcid"] %in% sequence)
        }
        UpSetR::upset(sequence.matrix,
              sets = samples,
              nsets = length(samples), 
              nintersects = NA,
              mainbar.y.label = "Number of intersecting sequences",
              sets.x.label = "Number of sequences",
              line.size = 0.5,
              point.size = 1,
              text.scale = 1, 
              mb.ratio = c(0.7, 0.3),
              show.numbers = labels,
              matrix.dot.alpha = 0,
              query.legend = "bottom",
              queries = list(list(query = queryFunction, 
                                  params = list(productive.aa[[color.sample]]$aminoAcid), 
                                  color = "#377eb8",
                                  active = TRUE,
                                  query.name = color.sample)))
    }
    
    if(!is.null(color.intersection)){
        UpSetR::upset(sequence.matrix,
              sets = samples,
              nsets = length(samples), 
              nintersects = NA,
              mainbar.y.label = "Number of intersecting sequences",
              sets.x.label = "Number of sequences",
              line.size = 0.5,
              point.size = 1,
              text.scale = 1, 
              mb.ratio = c(0.7, 0.3),
              show.numbers = labels,
              matrix.dot.alpha = 0,
              queries = list(list(query = elements, 
                                  params = list(color.intersection), 
                                  color = color,
                                  active = TRUE)))
    }
    
    if(is.null(color.sample) & is.null(color.intersection)){
        UpSetR::upset(sequence.matrix,
              sets = samples,
              nsets = length(samples), 
              nintersects = NA,
              mainbar.y.label = "Number of intersecting sequences",
              sets.x.label = "Number of sequences",
              line.size = 0.5,
              point.size = 1,
              text.scale = 1, 
              mb.ratio = c(0.7, 0.3),
              show.numbers = labels,
              matrix.dot.alpha = 0)
    }
}

#' Remove sequence
#' 
#' Removes an amino acid sequence and associated data from all instances within 
#' a list of data frames and then recomputes the frequencyCount.
#' 
#' @param file.list A list of data frames imported using the LymphoSeq function 
#' readImmunoSeq.  "aminoAcid", "count", and "frequencyCount" are required columns.
#' @param sequence A character vector of one or more amino acid sequences to 
#' remove from the list of data frames.
#' @return Returns a list of data frames like the one imported except all rows 
#' with the specified amino acid sequence are removed.  The frequencyCount is 
#' recalculated.
#' @examples
#' file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")
#' 
#' file.list <- readImmunoSeq(path = file.path)
#' 
#' searchSeq(list = file.list, sequence = "CASSDLIGNGKLFF")
#' 
#' cleansed <- removeSeq(file.list = file.list, sequence = "CASSDLIGNGKLFF")
#' 
#' searchSeq(list = cleansed, sequence = "CASSDLIGNGKLFF")
#' @export
#' @importFrom plyr llply
removeSeq <- function(file.list, sequence) {
    cleansed <- plyr::llply(file.list, function(x) 
        x[which(!(x[, "aminoAcid"] %in% sequence)), ])
    recompute <- list()
    i <- 1
    for (i in 1:length(cleansed)) {
        file <- cleansed[[i]]
        file$frequencyCount <- file$count/sum(file$count) * 100
        recompute <- c(recompute, list(file))
    }
    names(recompute) <- names(cleansed)
    return(recompute)
}

#' Unique sequences
#' 
#' Aggregates all productive sequences within a list of data frames by count.
#' 
#' @param productive.aa A list data frames of of productive amino acid sequences 
#' imported using the function LymphoSeq function productiveSeq where the 
#' aggregate parameter was set to "aminoAcid". 
#' @return A data frame of unique amino acid sequences from the list of 
#' data frames aggregated by count.
#' @examples
#' file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")
#' 
#' file.list <- readImmunoSeq(path = file.path)
#' 
#' productive.aa <- productiveSeq(file.list = file.list, aggregate = "aminoAcid")
#' 
#' unique.seqs <- uniqueSeqs(productive.aa = productive.aa)
#' @export
#' @importFrom plyr llply ldply
#' @importFrom stats aggregate
uniqueSeqs <- function(productive.aa) {
    if(any(unlist(lapply(productive.aa, function(x) 
        x[, "aminoAcid"] == "" |
        grepl("\\*", x[, "aminoAcid"]) | 
        duplicated(x[, "aminoAcid"]))))){
        stop("Your list contains unproductive sequences or has not been aggreated for productive amino acid sequences.  Remove unproductive sequences first using the function productiveSeq with the aggregate parameter set to 'aminoAcid'.", call. = FALSE)
    }
    unique.seq <- plyr::ldply(productive.aa, function(x) x[, c("aminoAcid", "count")])
    unique.seq$.id <- NULL
    unique.seq <- aggregate(data = unique.seq, count ~ aminoAcid, sum)
    unique.seq <- unique.seq[order(unique.seq$count, decreasing = TRUE),]
    return(unique.seq)
}

#' Merge files
#' 
#' Merges two or more sample data frames into a single data frame and aggregates 
#' count, frequencyCount, and estimatedNumberGenomes.
#' 
#' @param samples A character vector of the names of the samples that are to be 
#' merged in file.list.
#' @param file.list A list of data frames imported using the LymphoSeq function
#' readImmunoSeq that contain the sample names that are to be merged.  "aminoAcid", 
#' "nucleotide", "count" and "frequencyCount" are required columns.
#' @return Returns a data frame of the merged samples.  The values of count, 
#' frequencyCount, and estimatedNumberGenomes are aggregated.  That is, the sum 
#' of count and estimatedNumberGenomes columns of the merged data frame should 
#' equal the sum of the columns from the unmerged samples.  Likewise, the 
#' frequencyCount of the merged data frame should add up to 100\%.  All other 
#' columns in the unmerged data frames are included in the merge data frame.
#' @examples
#' file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")
#' 
#' file.list <- readImmunoSeq(path = file.path)
#' 
#' TCRB_Day949_Merged <- mergeFiles(samples = c("TRB_CD4_949", 
#'    "TRB_CD8_949"), file.list)
#' 
#' # To combine the merged data frames with file.list
#' file.list <- c(list("TCRB_Day949_Merged" = TCRB_Day949_Merged), file.list)
#' @export
#' @importFrom stats aggregate
mergeFiles <- function(samples, file.list) {
    merged <- data.frame()
    i <- 1
    for (i in 1:length(samples)) {
        file <- file.list[[as.character(samples[i])]]
        merged <- rbind(merged, file)
    }
    count <- aggregate(count ~ nucleotide, data = merged, FUN = sum)
    if (any(grepl("estimatedNumberGenomes", colnames(merged)))) {
        merged$estimatedNumberGenomes[is.na(merged$estimatedNumberGenomes)] <- 0
        estimatedNumberGenomes <- aggregate(estimatedNumberGenomes ~ nucleotide, 
                                            data = merged, FUN = sum)
    }
    merged$count <- NULL
    merged$estimatedNumberGenomes <- NULL
    merged <- merged[!duplicated(merged$nucleotide), ]
    merged <- Reduce(function(x, y) 
        merge(x, y, by = "nucleotide"), list(count, estimatedNumberGenomes, merged))
    merged$frequencyCount <- (merged$count/sum(merged$count)) * 100
    return(merged)
} 

#' Bhattacharyya matrix
#' 
#' Calculates the Bhattacharyya coefficient of all pairwise comparison from a 
#' list of data frames.
#' 
#' @param productive.seqs A list data frames of productive sequences generated 
#' by the LymphoSeq function productiveSeq.  "frequencyCount" and "aminoAcid" 
#' are a required columns.
#' @return A data frame of Bhattacharyya coefficients calculated from all 
#' pairwise comparisons from a list of sample data frames.  The Bhattacharyya 
#' coefficient is a measure of the amount of overlap between two samples.  The 
#' value ranges from 0 to 1 where 1 indicates the sequence frequencies are 
#' identical in the two samples and 0 indicates no shared frequencies.
#' @examples
#' file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")
#' 
#' file.list <- readImmunoSeq(path = file.path)
#' 
#' productive.aa <- productiveSeq(file.list, aggregate = "aminoAcid")
#' 
#' bhattacharyyaMatrix(productive.seqs = productive.aa)
#' @seealso \code{\link{pairwisePlot}} for plotting results as a heat map.
#' @export
bhattacharyyaMatrix <- function(productive.seqs) {
    l <- length(productive.seqs)
    m <- matrix(nrow = l, ncol = l)
    rownames(m) <- names(productive.seqs)
    colnames(m) <- names(productive.seqs)
    for (i in 1:l) {
        for (j in 1:i) {
            m[i, j] <- bhattacharyyaCoefficient(productive.seqs[[i]], productive.seqs[[j]])
            m[j, i] <- m[i, j]
        }
    }
    m <- m[, colnames(m)[order(nchar(colnames(m)), colnames(m), 
                               decreasing = TRUE)]]
    m <- m[colnames(m)[order(nchar(colnames(m)), colnames(m), 
                             decreasing = TRUE)], ]
    d <- as.data.frame(m)
    return(d)
}

#' Pairwise comparison plot
#' 
#' Creates a heat map from a similarity or Bhattacharyya matrix.
#' 
#' @param matrix A similarity or Bhattacharyya matrix produced by the LymphoSeq 
#' functions similarityMatrix or bhattacharyyaMatrix.
#' @return A pairwise comparison heat map.
#' @details The plot is made using the package ggplot2 and can be reformatted
#' using ggplot2 functions.  See examples below.
#' @seealso An excellent resource for examples on how to reformat a ggplot can 
#' be found in the R Graphics Cookbook online (\url{http://www.cookbook-r.com/Graphs/}).
#' The functions to create the similarity or Bhattacharyya matrix can be found 
#' here: \code{\link{similarityMatrix}} and \code{\link{bhattacharyyaMatrix}}
#' @examples
#' file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")
#' 
#' file.list <- readImmunoSeq(path = file.path)
#' 
#' productive.aa <- productiveSeq(file.list = file.list, aggregate = "aminoAcid")
#' 
#' similarity.matrix <- similarityMatrix(productive.seqs = productive.aa)
#' 
#' pairwisePlot(matrix = similarity.matrix)
#' 
#' bhattacharyya.matrix <- bhattacharyyaMatrix(productive.seqs = productive.aa)
#' 
#' pairwisePlot(matrix = bhattacharyya.matrix)
#' 
#' # Change plot color, title legend, and add title
#' pairwisePlot(matrix = similarity.matrix) + 
#'    ggplot2::scale_fill_gradient(low = "#deebf7", high = "#3182bd") + 
#'    ggplot2::labs(fill = "Similarity score") + ggplot2::ggtitle("Figure Title")
#' @export
#' @import ggplot2
#' @importFrom reshape melt.data.frame
#' @importFrom stats na.omit
pairwisePlot <- function(matrix) {
    i <- 1
    l <- length(matrix)
    p <- l - 1
    for (i in 1:p) {
        j <- i + 1
        matrix[i, j:l] <- NA
    }
    matrix$Samples <- rownames(matrix)
    melt <- reshape::melt.data.frame(matrix, id.vars = "Samples")
    melt <- na.omit(melt)
    melt$variable <- factor(melt$variable, levels = rownames(matrix))
    melt$Samples <- factor(melt$Samples, levels = rev(rownames(matrix)))
    names(melt) = c("Sample.x", "Sample.y", "Score")
    ggplot(data = melt, aes_string(x = "Sample.x", y = "Sample.y", fill = "Score")) + 
        geom_tile() + 
        scale_fill_gradient(low = "#fee8c8", high = "#e34a33") + 
        theme_classic() + 
        labs(x = "", y = "", fill = "") + 
        theme(axis.text.x = element_text(angle = 90, hjust = 1, vjust = 0.5))
}

#' Lorenz curve
#' 
#' Plots a Lorenz curve derived from the frequency of the amino acid sequences.
#' 
#' @param samples A character vector of sample names in list.
#' @param list A list data frames generated using the LymphoSeq function readImmunoSeq 
#' or productiveSeq.  "frequencyCount" is a required column.
#' @return Returns a Lorenz curve.
#' @details The Gini coefficient is an alternative metric used to calculate 
#' repertoire diversity and is derived from the Lorenz curve.  The Lorenz curve 
#' is drawn such that x-axis represents the cumulative percentage of unique 
#' sequences and the y-axis represents the cumulative percentage of reads.  A 
#' line passing through the origin with a slope of 1 reflects equal frequencies 
#' of all sequences.  The Gini coefficient is the ratio of the area between the 
#' line of equality and the observed Lorenz curve over the total area under the 
#' line of equality.
#' 
#' The plot is made using the package ggplot2 and can be reformatted
#' using ggplot2 functions.  See examples below.
#' @seealso An excellent resource for examples on how to reformat a ggplot can 
#' be found in the R Graphics Cookbook online (\url{http://www.cookbook-r.com/Graphs/}).
#' @examples
#' file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")
#' 
#' file.list <- readImmunoSeq(path = file.path)
#' 
#' lorenzCurve(samples = names(file.list), list = file.list)
#' 
#' productive.aa <- productiveSeq(file.list = file.list, aggregate = "aminoAcid")
#' 
#' lorenzCurve(samples = names(productive.aa), list = productive.aa)
#' 
#' # Change the legend labels, line colors, and add a title
#' samples <- c("TRB_Unsorted_0", "TRB_Unsorted_32", 
#'    "TRB_Unsorted_83", "TRB_Unsorted_949", "TRB_Unsorted_1320")
#' 
#' lorenz.curve <- lorenzCurve(samples = samples, list = productive.aa)
#' 
#' labels <- c("Day 0", "Day 32", "Day 83", "Day 949", "Day 1320")
#' 
#' colors <- c("navyblue", "red", "darkgreen", "orange", "purple")
#' 
#' lorenz.curve + ggplot2::scale_color_manual(name = "Samples", breaks = samples, 
#'    labels = labels, values = colors) + ggplot2::ggtitle("Figure Title")
#' @export
#' @import ggplot2
#' @importFrom RColorBrewer brewer.pal
#' @importFrom ineq Lc
lorenzCurve <- function(samples, list) {
    lorenz <- data.frame()
    i <- 1
    for (i in 1:length(samples)) {
        sample <- samples[i]
        file <- list[[sample]]
        lc <- ineq::Lc(file$frequencyCount)
        lcdf <- data.frame(L = lc$L, p = lc$p)
        lcdf$sample <- rep(sample, nrow(lcdf))
        lorenz <- rbind(lcdf, lorenz)
    }
    getPalette <- grDevices::colorRampPalette(RColorBrewer::brewer.pal(9, "Set1"))
    plot <- ggplot2::ggplot(lorenz, aes_string(x = "p", y = "L", color = "sample")) + 
        geom_line(size = 1) + 
        theme_minimal() + 
        scale_color_manual(values = getPalette(length(samples) + 1)) + 
        scale_y_continuous(expand = c(0, 0)) + 
        scale_x_continuous(expand = c(0,0)) + 
        geom_abline(intercept = 0, slope = 1, color = "grey", linetype = 2) + 
        coord_fixed() + 
        labs(x = "Cumulative percentage of unique sequences", 
             y = "Cumulative percentage of reads", color = "")
    return(plot)
}

#' Similarity score
#' 
#' Calculates the similarity score of two samples.
#' 
#' @param sample1 A data frame consisting of frequencies of antigen receptor 
#' sequences.  "aminoAcid" and "count" are a required columns.
#' @param sample2 A data frame consisting of frequencies of antigen receptor 
#' sequences.  "aminoAcid" and "count" are a required columns.
#' @return Returns the similarity score, a measure of the amount of 
#' overlap between two samples.  The value ranges from 0 to 1 where 1 indicates 
#' the sequence frequencies are identical in the two samples and 0 
#' indicates no shared frequencies.
#' @examples
#' file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")
#' 
#' file.list <- readImmunoSeq(path = file.path)
#' 
#' productive.aa <- productiveSeq(file.list, aggregate = "aminoAcid")
#' 
#' similarityScore(productive.aa[["TRB_Unsorted_32"]], productive.aa[["TRB_Unsorted_83"]])
#' @seealso \code{\link{similarityMatrix}}
#' @export
similarityScore <- function(sample1, sample2) {
    s1 <- sum(sample1[which(sample1[, "aminoAcid"] %in% sample2[, "aminoAcid"]), 
                      "count"])
    s2 <- sum(sample2[which(sample2[, "aminoAcid"] %in% sample1[, "aminoAcid"]), 
                      "count"])
    return((s1 + s2)/(sum(sample1[, "count"]) + sum(sample2[, "count"])))
}

#' Create phylogenetic tree
#' 
#' Create a phylogenetic tree using neighbor joining tree estimation for amino acid or 
#' nucleotide CDR3 sequences in a list of data frames.
#' 
#' @param list A list data frames of unproductive nucleotide sequences or productive 
#' nucleotide sequences generated by the LymphoSeq function productiveSeq.  
#' vFamilyName, dFamilyName, jFamilyName, and count are required columns.
#' @param sample A character vector indicating the name of the sample in the productive
#' sequence list. 
#' @param type A character vector indicating whether "aminoAcid" or "nucleotide" sequences
#' should be compared.
#' @param layout A character vector indicating the tree layout.  Options include 
#' "rectangular", "slanted", "fan", "circular", "radial" and "unrooted".
#' @param label A Boolean indicating if the sequencing count should be shown next to the leaves.
#' @return Returns a phylogenetic tree where each leaf represents a sequence color coded by the
#' V, D, and J gene usage.  The number next to each leaf refers to the sequence count.  A triangle 
#' shaped leaf indicates the dominant sequence.  Refer to the ggtree Bioconductor package 
#' documentation for details on how to manipulate the tree.
#' @examples
#' file.path <- system.file("extdata", "IGH_sequencing", package = "LymphoSeq")
#' 
#' file.list <- readImmunoSeq(path = file.path)
#' 
#' productive.nt <- productiveSeq(file.list = file.list, aggregate = "nucleotide")
#' 
#' phyloTree(list = productive.nt, sample = "IGH_MVQ92552A_BL", type = "nucleotide", 
#'          layout = "rectangular")
#' 
#' phyloTree(list = productive.nt, sample = "IGH_MVQ92552A_BL", type = "aminoAcid", 
#'          layout = "circular")
#'          
#' # Add scale and title to figure
#' library(ggtree)
#' library(ggplot2)
#' phyloTree(list = productive.nt, sample = "IGH_MVQ92552A_BL", type = "aminoAcid", 
#'          layout = "rectangular") +
#'          ggtree::theme_tree2() +
#'          ggplot2::theme(legend.position = "right", legend.key = element_rect(colour = "white")) +
#'          ggplot2::ggtitle("Title")
#'          
#' # Hide legend and leaf labels
#' phyloTree(list = productive.nt, sample = "IGH_MVQ92552A_BL", type = "nucleotide", 
#'          layout = "rectangular", label = FALSE) +
#'          ggplot2::theme(legend.position="none")
#'          
#' @export
#' @import ggtree
#' @import ggplot2
#' @importFrom phangorn NJ
phyloTree <- function(list, sample, type = "nucleotide", layout = "rectangular", label = TRUE) {
    file <- list[[sample]]
    if(length(grep(pattern = "vFamilyName|dFamilyName|jFamilyName|count", names(file))) != 4){
        stop("vFamilyName, dFamilyName, jFamilyName, nucleotide, and count are required columns.  Try aggregating the sequences by 'nucleotide' usng the function productiveSeq.", call. = FALSE)
    }
    if(nrow(file) < 3){
        stop("Cannot draw phlogenetic tree with less than 3 sequences.", call. = FALSE)
    }
    file[file == ""] <- "unresolved"
    if(type == "nucleotide") {
        file <- file[nchar(file$nucleotide) > 9, ]
        distance <- adist(file$nucleotide, file$nucleotide)
        colnames(distance) <- rownames(distance) <- file$nucleotide
        names <- file$nucleotide
    }
    if(type == "aminoAcid") {
        file <- file[nchar(file$aminoAcid) > 3, ]
        distance <- adist(file$aminoAcid, file$aminoAcid)
        colnames(distance) <- rownames(distance) <- file$aminoAcid
        names <- file$aminoAcid
    }
    tree <- phangorn::NJ(distance)
    geneFamilies <- paste(file$vFamilyName, file$dFamilyName, file$jFamilyName)
    geneFamilies <- gsub(geneFamilies, pattern = "IGH|IGL|IGK|TCRB|TCRA", replacement = "")
    geneFamilies <- gsub(geneFamilies, pattern = "unresolved", replacement = "UNR")
    tree.annotation <- data.frame(names = names, count = file$count, 
                                  geneFamilies = geneFamilies, aminoAcid = file$aminoAcid,
                                  frequencyCount = round(file$frequencyCount, digits = 2), 
                                  dominant = c("Yes", rep("No", nrow(file) - 1)))
    getPalette <- grDevices::colorRampPalette(RColorBrewer::brewer.pal(9, "Set1"))
    plot <- ggtree::ggtree(tree, layout = layout) %<+% tree.annotation + 
        ggtree::geom_tippoint(aes_string(color = "geneFamilies", shape = "dominant"), size = 3) + 
        ggplot2::scale_color_manual(values = getPalette(length(unique(geneFamilies)))) + 
        ggplot2::guides(shape = FALSE) + 
        ggplot2::theme(legend.position = "bottom", legend.key = element_rect(colour = "white")) + 
        ggplot2::labs(color = "")
    if(label == TRUE){
        plot <- plot + ggplot2::geom_text(aes_string(label="count"), nudge_x = 0.5, hjust = 0, size = 2.5, na.rm = TRUE, check_overlap = TRUE)
    }
    return(plot)
}

#' Common sequences plot
#' 
#' Creates a scatter plot of just the sequences in common between two samples.
#' 
#' @param sample1 A name of a sample in a list of data frames generated by the 
#' LymphoSeq function productiveSeq.
#' @param sample2 A name of a sample in a list of data frames generated by the 
#' LymphoSeq function productiveSeq.
#' @param productive.aa A list of data frames of productive amino acid sequences 
#' produced by the LymphoSeq function productiveSeq containing the 
#' samples to be compared.
#' @param show A character vector specifying whether only the common sequences 
#' should be shown or all sequences.  Available options are "common" or "all".
#' @return Returns a frequency scatter plot of two samples showing only the 
#' shared sequences.
#' @details The plot is made using the package ggplot2 and can be reformatted
#' using ggplot2 functions.  See examples below.
#' @seealso An excellent resource for examples on how to reformat a ggplot can 
#' be found in the R Graphics Cookbook online (\url{http://www.cookbook-r.com/Graphs/}).
#' @examples
#' file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")
#' 
#' file.list <- readImmunoSeq(path = file.path)
#' 
#' productive.aa <- productiveSeq(file.list = file.list, aggregate = "aminoAcid")
#' 
#' commonSeqsPlot("TRB_Unsorted_32", "TRB_Unsorted_83", 
#'    productive.aa = productive.aa)
#' 
#' # Change the X and Y axises to log-10 scale
#' commonSeqsPlot("TRB_Unsorted_32", "TRB_Unsorted_83", 
#'    productive.aa = productive.aa) +
#'    ggplot2::scale_x_log10() + 
#'    ggplot2::scale_y_log10() + 
#'    ggplot2::annotation_logticks(sides = "bl")
#' @export
#' @import ggplot2
commonSeqsPlot <- function(sample1, sample2, productive.aa, show = "common") {
    if(any(unlist(lapply(productive.aa, function(x) 
        x[, "aminoAcid"] == "" |
        grepl("\\*", x[, "aminoAcid"]) | 
        duplicated(x[, "aminoAcid"]))))){
        stop("Your list contains unproductive sequences or has not been aggreated for productive amino acid sequences.  Remove unproductive sequences first using the function productiveSeq with the aggregate parameter set to 'aminoAcid'.", call. = FALSE)
    }
    if (show == "common") {
        common <- commonSeqs(samples = c(sample1, sample2), productive.aa = productive.aa)
        plot <- ggplot2::ggplot(data = common, aes_string(x = names(common)[2], y = names(common)[3], label = "aminoAcid")) + 
            geom_point() +
            theme_minimal() + 
            labs(x = paste(sample1, "frequency (%)"), y = paste(sample2, "frequency (%)"))
    }
    if (show == "all") {
        all <- merge(productive.aa[[sample1]], productive.aa[[sample2]], by = "aminoAcid", all = TRUE)
        all[is.na(all)] <- 0
        names(all)[names(all) == "frequencyCount.x"] <- sample1
        names(all)[names(all) == "frequencyCount.y"] <- sample2
        plot <- ggplot2::ggplot(data = all, aes_string(x = sample1, y = sample2, label = "aminoAcid")) + 
            geom_point() +
            theme_minimal() + 
            labs(x = paste(sample1, "frequency (%)"), y = paste(sample2, "frequency (%)"))
    }
    return(plot)
}

#' Sequence matrix
#' 
#' Creates a data frame with unique, productive amino acid sequences as rows and 
#' sample names as headers.  Each value in the data frame represents the 
#' frequency that the sequence appeared in the sample.
#' 
#' @param productive.aa A list data frames of of productive amino acid sequences 
#' generated by LymphoSeq function productiveSeq where the aggregate parameter 
#' was set to "aminoAcid". 
#' @param sequences A character vector of amino acid sequences of interest.  It 
#' is useful to specify the output from the LymphoSeq functions uniqueSeqs or 
#' topSeqs and subsetting the "aminoAcid" column.  See examples below.
#' @return Returns a data frame of unique, productive amino acid sequences as 
#' rows and the \% frequency it appears in each sample as columns.
#' @seealso \code{\link{topSeqs}} and \code{\link{uniqueSeqs}}
#' @examples
#' file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")
#' 
#' file.list <- readImmunoSeq(path = file.path)
#' 
#' productive.aa <- productiveSeq(file.list = file.list, aggregate = "aminoAcid")
#' 
#' top.seqs <- topSeqs(productive.seqs = productive.aa, top = 0.1)
#' 
#' sequence.matrix <- seqMatrix(productive.aa = productive.aa, 
#'    sequences = top.seqs$aminoAcid)
#' 
#' unique.seqs <- uniqueSeqs(productive.aa = productive.aa)
#' 
#' sequence.matrix <- seqMatrix(productive.aa = productive.aa, 
#'    sequences = unique.seqs$aminoAcid)
#' 
#' # It can be helpful to combine top.freq and sequence.matrix
#' top.freq <- topFreq(productive.aa = productive.aa, percent = 0)
#' 
#' sequence.matrix <- seqMatrix(productive.aa = productive.aa, sequences = top.freq$aminoAcid)
#' 
#' top.freq.matrix <- merge(top.freq, sequence.matrix)
#' @export
#' @importFrom plyr llply ldply
seqMatrix <- function(productive.aa, sequences) {
    if(any(unlist(lapply(productive.aa, function(x) 
        x[, "aminoAcid"] == "" |
        grepl("\\*", x[, "aminoAcid"]) | 
        duplicated(x[, "aminoAcid"]))))){
        stop("Your list contains unproductive sequences or has not been aggreated for productive amino acid sequences.  Remove unproductive sequences first using the function productiveSeq with the aggregate parameter set to 'aminoAcid'.", call. = FALSE)
    }
    sequence.matrix <- plyr::ldply(productive.aa, function(x) 
        x[match(sequences, x$aminoAcid), "frequencyCount"])
    rownames(sequence.matrix) <- sequence.matrix$.id
    sequence.matrix$.id <- NULL
    colnames(sequence.matrix) <- sequences
    sequence.matrix <- as.data.frame(t(sequence.matrix))
    sequence.matrix[is.na(sequence.matrix)] <- 0
    sequence.matrix$numberSamples <- apply(sequence.matrix, 1, function(x) 
        length(which(x > 0)))
    sequence.matrix <- sequence.matrix[order(sequence.matrix$numberSamples, decreasing = TRUE), ]
    sequence.matrix$aminoAcid = rownames(sequence.matrix)
    rownames(sequence.matrix) = NULL
    sequence.matrix <- sequence.matrix[c("aminoAcid", "numberSamples", setdiff(names(sequence.matrix), c("aminoAcid", "numberSamples")))]
    return(sequence.matrix)
}

#' Productive sequences
#' 
#' Remove unproductive CDR3 sequences from a list of data frames.
#' 
#' @param file.list A list of data frames consisting antigen receptor sequencing 
#' data imported by the LymphoSeq function readImmunoSeq. "aminoAcid", "count", and 
#' "frequencyCount" are required columns.
#' @param aggregate Indicates whether the values of "count", "frequencyCount", 
#' and "esimatedNumberGenomes" should be aggregated by amino acid or nucleotide 
#' sequence.  Acceptable values are "aminoAcid" or "nucleotide".  If "aminoAcid" 
#' is selected, then resulting data frame will have columns corresponding to 
#' aminoAcid, count, frequencyCount, and estimatedNumberGenomes (if this 
#' column is available).  If "nucleotide" is selected then all columns in the 
#' original list will be present in the outputted list.  The difference in 
#' output is due to the fact that the same amino acid CDR3 sequence may be 
#' encoded by multiple unique nucleotide sequences with differing V, D, and J 
#' genes.
#' @param prevalence A Boolean value indicating if a new column should be added 
#' to each of the data frames giving the prevalence of each CDR3 amino acid 
#' sequence in 55 healthy donor peripheral blood samples.  TRUE means the column 
#' is added and FALSE means it is not.  Values range from 0 to 100\% where 
#' 100\% means the sequence appeared in the blood of all 55 individuals.  The 
#' prevalenceTRB database is located in a separate package called LymphoSeqDB 
#' that should be loaded automatically.
#' @return Returns a list of data frames of productive amino acid sequences with
#' recomputed values for "count", "frequencyCount", and 
#' "esimatedNumberGenomes".  A productive sequences is defined as a sequences 
#' that is in frame and does not have an early stop codon.
#' @examples
#' file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")
#' 
#' file.list <- readImmunoSeq(path = file.path)
#' 
#' productive.nt <- productiveSeq(file.list = file.list, 
#'    aggregate = "nucleotide", prevalence = FALSE)
#' 
#' productive.aa <- productiveSeq(file.list = file.list, 
#'   aggregate = "aminoAcid", prevalence = TRUE)
#' @seealso Refer to the LymphoSeqDB package for details regarding the 
#' prevalenceTRB database.
#' @export
#' @importFrom plyr llply
#' @import LymphoSeqDB
productiveSeq <- function(file.list, aggregate = "aminoAcid", prevalence = FALSE) {
    productive.list <- plyr::llply(file.list, function(x) 
        productive(x, aggregate), .progress = "text")
    if (prevalence == TRUE) {
        if (aggregate != "aminoAcid") {
            stop("In order to add prevalence to your list of data frames, aggregate must be equal 'aminoAcid'.", call. = FALSE)
        }
        cat("Adding prevalence column...")
        i <- 1
        productive.list.prevalence <- list()
        for(i in 1:length(productive.list)) {
            file <- productive.list[[i]]
            file$prevalence <- LymphoSeqDB::prevalenceTRB[match(file$aminoAcid, LymphoSeqDB::prevalenceTRB$aminoAcid), "prevalence"]
            file$prevalence[is.na(file$prevalence)] <- 0
            productive.list.prevalence <- c(productive.list.prevalence, list(file))
        }
        names(productive.list.prevalence) <- names(productive.list)
        return(productive.list.prevalence[lapply(productive.list.prevalence,length) > 0])
    } else {
        return(productive.list[lapply(productive.list,length) > 0])
    }
} 

#' Top frequencies
#' 
#' Creates a data frame of the top productive amino acid sequences that have a 
#' specified minimum frequency threshold and reports the number of samples that 
#' the sequence appears in along with the minimum, maximum, and mean frequency 
#' across all samples.  For T cell receptor beta sequences, the \% prevalence 
#' and antigen specificity of that sequence is also provided.
#' 
#' @param productive.aa A list data frames of of productive amino acid sequences 
#' imported using the function LymphoSeq function productiveSeq where the 
#' aggregate parameter was set to "aminoAcid".  
#' @param percent The minimum \% frequency that the sequence appears in any of 
#' the listed samples.
#' @return A data frame of amino acid sequences and the number of samples that 
#' the sequence appears in along with the minimum, maximum, and mean frequency 
#' across all samples.  
#' For T cell receptor beta sequences, additionally reported is the 
#' \% prevalence that the sequence appears in 55 healthy donor blood samples.  
#' Also provided is the antigen specificity of that sequence if known by 
#' comparing it to a database of previously reported sequences in the 
#' literature.  The prevalenceTRB and publishedTRB databases are located in a 
#' separate package called LymphoSeqDB that should be loaded automatically.
#' @examples
#' file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")
#' 
#' file.list <- readImmunoSeq(path = file.path)
#' 
#' productive.aa <- productiveSeq(file.list = file.list, aggregate = "aminoAcid")
#' 
#' top.freq <- topFreq(productive.aa = productive.aa, percent = 0.1)
#' @seealso Refer to the LymphoSeqDB package for details regarding the 
#' prevalenceTRB and publishedTRB database.
#' @export
#' @import LymphoSeqDB
#' @importFrom dplyr group_by summarise
topFreq <- function(productive.aa, percent = 0.1) {
    if(any(unlist(lapply(productive.aa, function(x) 
        x[, "aminoAcid"] == "" | grepl("\\*", x[, "aminoAcid"]) | 
        duplicated(x[, "aminoAcid"]))))){
        stop("Your list contains unproductive sequences or has not been aggreated for productive amino acid sequences.  Remove unproductive sequences first using the function productiveSeq with the aggregate parameter set to 'aminoAcid'.", call. = FALSE)
    }
    frequencyCount <- NULL
    aminoAcid <- NULL
    top.seqs <- plyr::llply(productive.aa, function(x) 
        subset(x, frequencyCount >= percent, 
               select = aminoAcid))
    top.seqs <- Reduce(rbind, top.seqs)
    top.merged <- Reduce(rbind, productive.aa)
    top.merged <- top.merged[top.merged$aminoAcid %in% unique(top.seqs$aminoAcid), ]
    top.grouped <- dplyr::group_by(top.merged, aminoAcid)
    top.table <- data.frame(dplyr::summarise(top.grouped, 
                                             min(frequencyCount), 
                                             max(frequencyCount), 
                                             mean(frequencyCount), 
                                             length(aminoAcid)))
    colnames(top.table) <- c("aminoAcid", "minFrequency", "maxFrequency", 
                             "meanFrequency", "numberSamples")
    top.table <- top.table[order(top.table$numberSamples, 
                                 top.table$meanFrequency, 
                                 decreasing = TRUE), ]
    top.table$prevalence <- LymphoSeqDB::prevalenceTRB[match(top.table$aminoAcid, 
                                                             LymphoSeqDB::prevalenceTRB$aminoAcid), 
                                                       "prevalence"]
    top.table$prevalence[is.na(top.table$prevalence)] <- 0
    top.table$antigen <- as.character(LymphoSeqDB::publishedTRB[match(top.table$aminoAcid, 
                                                                      LymphoSeqDB::publishedTRB$aminoAcid), 
                                                                "antigen"])
    top.table <- replace(top.table, is.na(top.table), "")
    return(top.table)
}

#' Common sequences Venn diagram
#' 
#' Creates a Venn diagram comparing the number of common sequences in two or 
#' three samples.
#' 
#' @param samples A character vector of two or three names of samples in 
#' productive.seqs to compare.
#' @param productive.seqs A list of productive amino acid sequences generated
#' by the LymphoSeq function productiveSeq.
#' @return Returns a a Venn diagram of the number of common sequences between
#' two or three samples.
#' @seealso \code{\link{commonSeqs}}
#' @examples
#' file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")
#' 
#' file.list <- readImmunoSeq(path = file.path)
#' 
#' productive.aa <- productiveSeq(file.list = file.list, aggregate = "aminoAcid")
#' 
#' # Plot a triple Venn diagram
#' commonSeqsVenn(samples = c("TRB_Unsorted_0", 
#'    "TRB_Unsorted_32", "TRB_Unsorted_83"), 
#'    productive.seqs = productive.aa)
#' 
#' # Plot a double Venn diagram
#' commonSeqsVenn(samples = c("TRB_Unsorted_0", 
#'    "TRB_Unsorted_32"), productive.seqs = productive.aa)
#' 
#' # Save Venn diagram as a .png file to working directory
#' png(filename = "Venn diagram.png", res = 300, units = "in", height = 5, width = 5)
#' 
#' commonSeqsVenn(samples = c("TRB_Unsorted_0", "TRB_Unsorted_32"), 
#'    productive.seqs = productive.aa)
#' 
#' dev.off()
#' @export
#' @importFrom VennDiagram draw.pairwise.venn draw.triple.venn
#' @importFrom grid grid.newpage grid.draw
commonSeqsVenn <- function(samples, productive.seqs) {
    if (length(samples) > 3 | length(samples) < 2) {
        stop("Please enter 2 or 3 samples.")
    }
    if (length(samples) == 2) {
        a <- productive.seqs[[samples[1]]]
        b <- productive.seqs[[samples[2]]]
        grid::grid.newpage()
        venn <- VennDiagram::draw.pairwise.venn(area1 = length(a$aminoAcid), 
                                                area2 = length(b$aminoAcid), 
                                                cross.area = length(intersect(a$aminoAcid, b$aminoAcid)), 
                                                category = c(samples[1], samples[2]), 
                                                cat.fontfamily = rep("sans", 2), 
                                                fontfamily = rep("sans", 3), 
                                                fill = c("#3288bd", "#d53e4f"), 
                                                cat.pos = c(0, 0),
                                                cat.dist = rep(0.025, 2),
                                                cex = 1, 
                                                cat.cex = 0.7,
                                                lwd = rep(2, 2))
        grid::grid.draw(venn)
    }
    if (length(samples) == 3) {
        a <- productive.seqs[[samples[1]]]
        b <- productive.seqs[[samples[2]]]
        c <- productive.seqs[[samples[3]]]
        grid::grid.newpage()
        venn <- VennDiagram::draw.triple.venn(area1 = length(a$aminoAcid), 
                                              area2 = length(b$aminoAcid), 
                                              area3 = length(c$aminoAcid), 
                                              n12 = length(intersect(a$aminoAcid, b$aminoAcid)), 
                                              n23 = length(intersect(b$aminoAcid, c$aminoAcid)), 
                                              n13 = length(intersect(a$aminoAcid, c$aminoAcid)), 
                                              n123 = length(Reduce(intersect, list(a$aminoAcid, b$aminoAcid, c$aminoAcid))), 
                                              category = c(samples[1], samples[2], samples[3]), 
                                              cat.fontfamily = rep("sans", 3), 
                                              fontfamily = rep("sans", 7), 
                                              fill = c("#3288bd", "#abdda4", "#d53e4f"), 
                                              cat.pos = c(0, 0, 180), 
                                              cat.dist = rep(0.025, 3),
                                              cex = 1, 
                                              cat.cex = 0.7,
                                              lwd = rep(2, 3))
        grid::grid.draw(venn)
    }
} 

#' Chord diagram of VJ or DJ gene associations
#' 
#' Creates a chord diagram showing VJ or DJ gene associations from one or more 
#' samples.
#' 
#' @param sample A data frame consisting of frequencies of antigen receptor 
#' sequences.  "vFamilyName", "jFamilyName", and if applicable, "dFamilyName" 
#' are a required columns.  Using output from the LymphoSeq function topSeqs is
#' recommended.
#' @param association A character vector of gene familes to associate.  Options 
#' include "VJ" or "DJ".
#' @param colors A character vector of 2 colors corresponding to the V/D and J 
#' gene colors respectively.
#' @details The size of the ribbons connecting VJ or DJ genes correspond to the 
#' number of samples or number of sequences that make up that recombination 
#' event.  The thicker the ribbon, the higher the frequency of the recombination.
#' @return Returns a chord diagram showing VJ or DJ gene associations from one or 
#' more samples.
#' @seealso \code{\link{topSeqs}}
#' @examples
#' file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")
#' 
#' file.list <- readImmunoSeq(path = file.path)
#' 
#' productive.nt <- productiveSeq(file.list = file.list, aggregate = "nucleotide")
#' 
#' top.seqs <- topSeqs(productive.seqs = productive.nt, top = 1)
#' 
#' chordDiagramVDJ(sample = top.seqs, association = "VJ", colors = c("red", "blue"))
#' 
#' # Remove "TCRB" from gene family name
#' top.seqs <- as.data.frame(apply(top.seqs, 2, function(x) gsub("TCRB", "", x)))
#' 
#' chordDiagramVDJ(sample = top.seqs, association = "VJ", colors = c("red", "blue"))
#' @export
#' @importFrom circlize colorRamp2 chordDiagram
chordDiagramVDJ <- function(sample, association = "VJ", colors = c("red", "blue")) {
    if (association == "VJ") {
        if (!all(c("vFamilyName", "jFamilyName") %in% colnames(sample))) {
            stop("The source data frame does not contain the required columns 'vFamilyName' and 'jFamilyName'.")
        }
        vj <- sample[, c("vFamilyName", "jFamilyName")]
        vj[is.na(vj) | vj == ""] <- "Unresolved"
        vj$vFamilyName <- as.character(vj$vFamilyName)
        vj$jFamilyName <- as.character(vj$jFamilyName)
        table <- table(vj$vFamilyName, vj$jFamilyName)
        matrix <- as.matrix(as.data.frame.matrix(table))
        ribbon.color <- circlize::colorRamp2(range(matrix), c("grey", "black"))
        circlize::chordDiagram(matrix, 
                               annotationTrack = c("grid", "name"), 
                               grid.col = c(rep(colors[1], dim(matrix)[1]), rep(colors[2], dim(matrix)[2])), 
                               col = ribbon.color)
    }
    if (association == "DJ") {
        if (!all(c("dFamilyName", "jFamilyName") %in% colnames(sample))) {
            stop("The source data frame does not contain the required columns 'dFamilyName' and 'jFamilyName'.")
        }
        dj <- sample[, c("dFamilyName", "jFamilyName")]
        dj[is.na(dj) | dj == ""] <- "Unresolved"
        dj$dFamilyName <- as.character(dj$dFamilyName)
        dj$jFamilyName <- as.character(dj$jFamilyName)
        table <- table(dj$dFamilyName, dj$jFamilyName)
        matrix <- as.matrix(as.data.frame.matrix(table))
        ribbon.color <- circlize::colorRamp2(range(matrix), c("grey", "black"))
        circlize::chordDiagram(matrix, 
                               annotationTrack = c("grid", "name"), 
                               grid.col = c(rep(colors[1], dim(matrix)[1]), rep(colors[2], dim(matrix)[2])), 
                               col = ribbon.color)
    }
}

#' Align mutliple sequences
#' 
#' Perform multiple sequence alignment using one of three methods and output results to the 
#' console or as a pdf file.  One may perform the alignment of all amino acid or nucleotide
#' sequences in a single sample.  Alternatively, one may search for a given sequence 
#' within a list of samples using an edit distance threshold.
#' 
#' @param list A list of data frames consisting of antigen receptor sequences 
#' imported by the LymphoSeq function readImmunoSeq.
#' @param sample A character vector indicating the name of the sample in the productive
#' sequence list. 
#' @param sequence A character vector of one ore more amino acid or nucleotide 
#' CDR3 sequences to search.
#' @param editDistance An integer giving the minimum edit distance that the 
#' sequence must be less than or equal to.  See details below.
#' @param type A character vector indicating whether "aminoAcid" or "nucleotide" sequences
#' should be aligned.  If "aminoAcid" is specified, then run productiveSeqs first.
#' @param method A character vector indicating the multiple sequence alignment method to 
#' be used.  Refer to the Bioconductor msa package for more details.  Options incude 
#' "ClustalW", "ClustalOmega", and "Muscle".
#' @param output A character vector indicating where the multiple sequence alignemnt should be
#' printed.  Options include "console" or "pdf".  If "pdf" is selected, the file is saved to
#' the working directory.  For "pdf" to work, Texshade must be installed.  Refer to the 
#' Bioconductor package msa installation instructions for more details.
#' @details Edit distance is a way of quantifying how dissimilar two sequences 
#' are to one another by counting the minimum number of operations required to 
#' transform one sequence into the other.  For example, an edit distance of 0 
#' means the sequences are identical and an edit distance of 1 indicates that 
#' the sequences different by a single amino acid or nucleotide.
#' 
#' @return Performs a multiple sequence alignemnt and prints to the console or saves a pdf to 
#' the working directory.
#' @seealso If having trouble saving pdf files, refer to Biconductor package msa for
#' installation instructions
#' \url{http://bioconductor.org/packages/release/bioc/vignettes/msa/inst/doc/msa.pdf}
#' @examples
#' file.path <- system.file("extdata", "IGH_sequencing", package = "LymphoSeq")
#' 
#' file.list <- readImmunoSeq(path = file.path)
#' 
#' productive.nt <- productiveSeq(file.list = file.list, aggregate = "nucleotide")
#' 
#' alignSeq(list = productive.nt, sample = "IGH_MVQ92552A_BL", type = "nucleotide", 
#'          method = "ClustalW", output = "console")
#' @export
#' @importFrom Biostrings DNAStringSet
#' @importFrom Biostrings AAStringSet
#' @import msa
alignSeq = function(list, sample = NULL, sequence = NULL, editDistance = 15, output = "console", type = "nucleotide", method = "ClustalOmega") {
    if(!is.null(sequence) & is.null(sample)){
        file <- searchSeq(list = list, sequence = sequence, editDistance = editDistance, type = type, match = "partial")
        if(is.null(file)){
            stop("There are no sequences to be aligned", call. = FALSE)
        }
    }
    if(!is.null(sequence) & !is.null(sample)){
        file <- searchSeq(list = list[sample], sequence = sequence, editDistance = editDistance, type = type, match = "partial")
        if(is.null(file)){
            stop("There are no sequences to be aligned", call. = FALSE)
        }
    }
    if(is.null(sequence)){
        file <- list[[sample]] 
    }
    if(nrow(file) > 150){
        file <- file[1:150,]
        message("Only the first 150 sequences will be aligned")
    }
    file[file == ""] <- "unresolved"
    if(type == "nucleotide"){
        names(file)[which(names(file) == "foundSequnece")] <- "nucleotide"
        file <- file[nchar(file$nucleotide) > 3, ]
        string <- Biostrings::DNAStringSet(file$nucleotide)
    }
    if(type == "aminoAcid"){
        names(file)[which(names(file) == "foundSequnece")] <- "aminoAcid"
        file <- file[nchar(file$aminoAcid) > 3, ]
        string <- Biostrings::AAStringSet(file$aminoAcid)
    }
    if(nrow(file) < 3){
        stop("There are less than 3 sequences to be aligned", call. = FALSE)
    }
    if(!is.null(sequence)){
        names(string) <- paste(file$sample)
    } else {
        names(string) <- paste(file$vFamilyName, file$dFamilyName, file$jFamilyName, file$count)
    }
        names(string) <- gsub(names(string), pattern = "IGH|IGL|IGK|TCRB|TCRA", replacement = "")
        names(string) <- gsub(names(string), pattern = "unresolved", replacement = "UNR")
        alignment <- msa::msa(string, method = method)
        if(output == "console"){
            print(alignment, show = "complete")
        }
        if(output == "pdf"){
            if(!is.null(sample)){
                file.name <- paste(names(list[sample]), ".pdf", sep = "")
            } else {
                file.name <- "Sequence_aligment.pdf"
            }
            msa::msaPrettyPrint(alignment, output = "pdf", file = file.name, 
                                showNumbering = "right", showNames = "left", showConsensus = "top",  
                                shadingMode = "similar", shadingColors = "blues",
                                paperWidth = ncol(alignment)*0.1 + 5, paperHeight = nrow(alignment)*0.1 + 5,
                                showLogo = "bottom", showLogoScale = "right", logoColors = "rasmol",
                                psFonts = TRUE, showLegend = TRUE, askForOverwrite = FALSE,
                                furtherCode=c("\\defconsensus{.}{lower}{upper}","\\showruler{1}{top}"))
            message(paste(file.name, "saved to", getwd()))
        }
}

#' Search for T cell receptor beta CDR3 amino acid sequences with known antigen 
#' specificity
#' 
#' Search for published T cell receptor beta CDR3 amino acid sequences with 
#' known antigen specificity in a list of data frames.
#' 
#' @param list A list of data frames generated by the LymphoSeq functions 
#' readImmunoSeq or productiveSeq.  "aminoAcid", "frequencyCount", and "count" 
#' are required columns.
#' @return Returns a data frame of each sample name and instance in the sample 
#' that the published TCR sequence appeared along with additional 
#' information including antigen specificity, epitope, HLA type, and PubMed ID 
#' (PMID) for the reference where the sequence was characterized.  The 
#' publishedTRB database is located in a separate package called LymphoSeqDB 
#' that should be loaded automatically.
#' @examples
#' file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")
#' 
#' file.list <- readImmunoSeq(path = file.path)
#' 
#' productive.aa <- productiveSeq(file.list = file.list, aggregate = "aminoAcid")
#' 
#' searchPublished(list = productive.aa)
#' @seealso Refer to the LymphoSeqDB package for details regarding the 
#' publishedTRB database.
#' @export
#' @importFrom plyr llply
#' @import LymphoSeqDB
searchPublished <- function(list) {
    search <- plyr::llply(list, function(x) 
        x[which(x[, "aminoAcid"] %in% LymphoSeqDB::publishedTRB$aminoAcid), ])
    found <- NULL
    l <- 1
    for (l in 1:length(search)) {
        if (nrow(search[[l]]) != 0) {
            search[[l]] <- cbind(rep(names(search)[l], 
                                     nrow(search[[l]])), search[[l]])
            colnames(search[[l]])[1] <- "sample"
            found <- rbind(found, search[[l]])
        }
    }
    if (is.null(found)) {
        message("No sequences found.")
    } else {
        found$prevalence = NULL
        found <- merge(found, LymphoSeqDB::publishedTRB, by = "aminoAcid")
        found <- found[c("sample", setdiff(names(found), "sample"))]
        return(found)
    }
}

#' Clonality
#' 
#' Creates a data frame giving the total number of sequences, number of unique 
#' productive sequences, number of genomes, entropy, clonality, Gini 
#' coefficient, and the frequency (\%) of the top productive sequences in a list 
#' of sample data frames.
#' 
#' @param file.list A list of data frames consisting of antigen receptor 
#' sequencing imported by the LymphoSeq function readImmunoSeq. "aminoAcid", "count", 
#' and "frequencyCount" are required columns.  "estimatedNumberGenomes" is optional.  
#' Note that clonality is usually calculated from productive nucleotide sequences.  
#' Therefore, it is not recommended to run this function using a productive sequence
#' list aggregated by amino acids.
#' @return Returns a data frame giving the total number of sequences, number of 
#' unique productive sequences, number of genomes, clonality, Gini coefficient, 
#' and the frequency (\%) of the top productive sequence in each sample.
#' @details Clonality is derived from the Shannon entropy, which is calculated 
#' from the frequencies of all productive sequences divided by the logarithm of 
#' the total number of unique productive sequences.  This normalized entropy 
#' value is then inverted (1 - normalized entropy) to produce the clonality 
#' metric.  
#' 
#' The Gini coefficient is an alternative metric used to calculate repertoire 
#' diversity and is derived from the Lorenz curve.  The Lorenz curve is drawn 
#' such that x-axis represents the cumulative percentage of unique sequences and 
#' the y-axis represents the cumulative percentage of reads.  A line passing 
#' through the origin with a slope of 1 reflects equal frequencies of all clones.  
#' The Gini coefficient is the ratio of the area between the line of equality 
#' and the observed Lorenz curve over the total area under the line of equality.  
#' Both Gini coefficient and clonality are reported on a scale from 0 to 1 where 
#' 0 indicates all sequences have the same frequency and 1 indicates the 
#' repertoire is dominated by a single sequence.
#' @examples
#' file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")
#' 
#' file.list <- readImmunoSeq(path = file.path)
#' 
#' clonality(file.list = file.list)
#' @seealso \code{\link{lorenzCurve}}
#' @export
#' @importFrom ineq Gini
clonality <- function(file.list) {
    table <- data.frame(samples = names(file.list))
    i <- 1
    for (i in 1:length(file.list)) {
        file <- file.list[[i]]
        total.reads <- nrow(file)
        total.count <- sum(file$count)
        productive <- file[!grepl("\\*", file$aminoAcid) & file$aminoAcid != "", ]
        frequency <- productive$count/sum(productive$count)
        entropy <- -sum(frequency * log2(frequency), na.rm = TRUE)
        unique.productive <- nrow(productive)
        clonality <- 1 - round(entropy/log2(unique.productive), digits = 6)
        table$totalSequences[i] <- total.reads
        table$uniqueProductiveSequences[i] <- unique.productive
        table$totalCount[i] <- total.count
        table$clonality[i] <- clonality
        table$giniCoefficient[i] <- ineq::Gini(frequency)
        table$topProductiveSequence[i] <- max(frequency) * 100
        if (any(grepl("estimatedNumberGenomes", colnames(file)))) {
            file$estimatedNumberGenomes <- suppressWarnings(as.integer(file$estimatedNumberGenomes))
            total.genomes <- sum(file$estimatedNumberGenomes)
            table$totalGenomes[i] <- ifelse(total.genomes == 0, NA, total.genomes)
        } else {
            table$totalGenomes[i] <- NA
        }
    }
    table <- table[order(table$topProductiveSequence, decreasing = TRUE), ]
    rownames(table) <- NULL
    return(table)
} 

#' Bhattacharyya coefficient
#' 
#' Calculates the Bhattacharyya coefficient of two samples.
#' 
#' @param sample1 A data frame consisting of frequencies of antigen receptor 
#' sequences.  "frequencyCount" is a required column.
#' @param sample2 A data frame consisting of frequencies of antigen receptor 
#' sequences.  "frequencyCount" is a required column.
#' @return Returns the Bhattacharyya coefficient, a measure of the amount of 
#' overlap between two samples.  The value ranges from 0 to 1 where 1 indicates 
#' the sequence frequencies are identical in the two samples and 0 indicates no 
#' shared frequencies. 
#' @examples
#' file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")
#' 
#' file.list <- readImmunoSeq(path = file.path)
#' 
#' productive.aa <- productiveSeq(file.list, aggregate = "aminoAcid")
#' 
#' bhattacharyyaCoefficient(productive.aa[["TRB_Unsorted_32"]], 
#'    productive.aa[["TRB_Unsorted_83"]])
#' @seealso \code{\link{bhattacharyyaMatrix}}
#' @export
bhattacharyyaCoefficient <- function(sample1, sample2) {
    p <- sample1[which(sample1[, "aminoAcid"] %in% sample2[, "aminoAcid"]), ]
    p$frequencyCount <- p$frequencyCount/100
    q <- sample2[which(sample2[, "aminoAcid"] %in% sample1[, "aminoAcid"]), ]
    q$frequencyCount <- q$frequencyCount/100
    s <- p[, "frequencyCount"] * q[, "frequencyCount"]
    bc <- sum(sqrt(s))
    return(bc)
}

## ----results = "hide"---------------------------------------------------------
library(LymphoSeq)

TCRB.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")

TCRB.list <- readImmunoSeq(path = TCRB.path)

## ----comment = ""-------------------------------------------------------------
names(TCRB.list)

## ----comment = ""-------------------------------------------------------------
lapply(TCRB.list, dim)

## ----comment = ""-------------------------------------------------------------
CMV <- TCRB.list[grep("CMV", names(TCRB.list))]
names(CMV)
TRB_Unsorted_0 <- TCRB.list[["TRB_Unsorted_0"]]
head(TRB_Unsorted_0)

## ----comment = ""-------------------------------------------------------------
TCRB.metadata <- read.csv(system.file("extdata", "TCRB_metadata.csv", package = "LymphoSeq"))
TCRB.metadata
selected <- as.character(TCRB.metadata[TCRB.metadata$phenotype == "Unsorted" & 
                                 TCRB.metadata$day > 300, "samples"])
TCRB.list.selected <- TCRB.list[selected]
names(TCRB.list.selected)

## ----results = "hide"---------------------------------------------------------
productive.TRB.aa <- productiveSeq(file.list = TCRB.list, aggregate = "aminoAcid", 
                               prevalence = FALSE)

## ----results = "hide"---------------------------------------------------------
productive.TRB.nt <- productiveSeq(file.list = TCRB.list, aggregate = "nucleotide", 
                               prevalence = FALSE)

## ----comment = ""-------------------------------------------------------------
head(TCRB.list[["TRB_Unsorted_0"]])

## ----comment = ""-------------------------------------------------------------
head(productive.TRB.aa[["TRB_Unsorted_0"]])

## ----comment = ""-------------------------------------------------------------
head(productive.TRB.nt[["TRB_Unsorted_0"]])

## ----comment = ""-------------------------------------------------------------
clonality(file.list = TCRB.list)

## ----results = "hide"---------------------------------------------------------
IGH.path <- system.file("extdata", "IGH_sequencing", package = "LymphoSeq")

IGH.list <- readImmunoSeq(path = IGH.path)

## ----comment = ""-------------------------------------------------------------
clonalRelatedness(list = IGH.list, editDistance = 10)

## ----results = "hide"---------------------------------------------------------
productive.IGH.nt <- productiveSeq(file.list = IGH.list, aggregate = "nucleotide")

## ----fig.width = 7, fig.height = 8, comment = ""------------------------------
phyloTree(list = productive.IGH.nt, sample = "IGH_MVQ92552A_BL", type = "nucleotide", 
         layout = "rectangular")

## ----comment = ""-------------------------------------------------------------
alignSeq(list = productive.IGH.nt, sample = "IGH_MVQ92552A_BL", type = "aminoAcid", 
         method = "ClustalW", output = "consule")

## ----comment = ""-------------------------------------------------------------
searchSeq(list = productive.TRB.aa, sequence = "CASSPVSNEQFF", type = "aminoAcid", 
          match = "global", editDistance = 0)

## ----comment = ""-------------------------------------------------------------
published <- searchPublished(list = productive.TRB.aa)
head(published)

## ----fig.width = 7, fig.height = 7, comment = ""------------------------------
lorenzCurve(samples = names(productive.TRB.aa), list = productive.TRB.aa)

## ----fig.width = 7, fig.height = 5, comment = ""------------------------------
topSeqsPlot(list = productive.TRB.aa, top = 10)

## ----comment = ""-------------------------------------------------------------
bhattacharyya.matrix <- bhattacharyyaMatrix(productive.seqs = productive.TRB.aa)
bhattacharyya.matrix
similarity.matrix <- similarityMatrix(productive.seqs = productive.TRB.aa)
similarity.matrix

## ----fig.width = 6.5, fig.height = 5, comment = ""----------------------------
pairwisePlot(matrix = bhattacharyya.matrix)

## ----comment = ""-------------------------------------------------------------
common <- commonSeqs(samples = c("TRB_Unsorted_0", "TRB_Unsorted_32"), 
                    productive.aa = productive.TRB.aa)
head(common)

## ----fig.width = 4, fig.height = 4, comment = ""------------------------------
commonSeqsVenn(samples = c("TRB_Unsorted_32", "TRB_Unsorted_83"), 
               productive.seqs = productive.TRB.aa)

## ----fig.width = 4, fig.height = 4, comment = ""------------------------------
commonSeqsVenn(samples = c("TRB_Unsorted_0", "TRB_Unsorted_32", "TRB_Unsorted_83"), 
               productive.seqs = productive.TRB.aa)

## ----fig.width = 4, fig.height = 4, comment = ""------------------------------
commonSeqsPlot("TRB_Unsorted_32", "TRB_Unsorted_83", 
               productive.aa = productive.TRB.aa, show = "common")

## ----fig.width = 7, fig.height = 5, comment = ""------------------------------
commonSeqsBar(productive.aa = productive.TRB.aa, 
              samples = c("TRB_CD4_949", "TRB_CD8_949", 
                          "TRB_Unsorted_949", "TRB_Unsorted_1320"), 
              color.sample = "TRB_CD8_949",
              labels = "no")

## ----comment = "", warning = FALSE--------------------------------------------
differentialAbundance(list = productive.TRB.aa, 
                      sample1 = "TRB_Unsorted_949", 
                      sample2 = "TRB_Unsorted_1320", 
                      type = "aminoAcid", q = 0.01)

## ----comment = ""-------------------------------------------------------------
unique.seqs <- uniqueSeqs(productive.aa = productive.TRB.aa)
head(unique.seqs)
sequence.matrix <- seqMatrix(productive.aa = productive.TRB.aa, sequences = unique.seqs$aminoAcid)
head(sequence.matrix)

## ----comment = ""-------------------------------------------------------------
top.freq <- topFreq(productive.aa = productive.TRB.aa, percent = 0.1)
head(top.freq)

## ----comment = ""-------------------------------------------------------------
top.freq <- topFreq(productive.aa = productive.TRB.aa, percent = 0)
top.freq.matrix <- merge(top.freq, sequence.matrix)
head(top.freq.matrix)

## ----fig.width = 7, fig.height = 5--------------------------------------------
cloneTrack(sequence.matrix = sequence.matrix, 
           productive.aa = productive.TRB.aa, 
           map = c("TRB_CD4_949", "TRB_CD8_949"), 
           label = c("CD4", "CD8"), 
           track = "CASSPPTGERDTQYF", 
           unassigned = FALSE)

## ----comment = ""-------------------------------------------------------------
vGenes <- geneFreq(productive.nt = productive.TRB.nt, locus = "V", family = TRUE)
head(vGenes)

## ----fig.width = 4, fig.height = 4--------------------------------------------
top.seqs <- topSeqs(productive.seqs = productive.TRB.nt, top = 1)
chordDiagramVDJ(sample = top.seqs, 
                association = "VJ", 
                colors = c("darkred", "navyblue"))

## ----fig.width = 4, fig.height = 4, warning = FALSE, message = FALSE----------
vGenes <- geneFreq(productive.nt = productive.TRB.nt, locus = "V", family = TRUE)
library(RColorBrewer)
library(grDevices)
RedBlue <- grDevices::colorRampPalette(rev(RColorBrewer::brewer.pal(11, "RdBu")))(256)
library(wordcloud)
wordcloud::wordcloud(words = vGenes[vGenes$samples == "TRB_Unsorted_83", "familyName"], 
                     freq = vGenes[vGenes$samples == "TRB_Unsorted_83", "frequencyGene"], 
                     colors = RedBlue)

## ----fig.width = 5, fig.height = 7, warning = FALSE, message = FALSE----------
library(reshape)
vGenes <- reshape::cast(vGenes, familyName ~ samples, value = "frequencyGene", sum)
rownames(vGenes) = as.character(vGenes$familyName)
vGenes$familyName = NULL
library(pheatmap)
pheatmap::pheatmap(vGenes, color = RedBlue, scale = "row")

## ----fig.width = 7, fig.height = 5.6, warning = FALSE, message = FALSE--------
vGenes <- geneFreq(productive.nt = productive.TRB.nt, locus = "V", family = TRUE)
library(ggplot2)
multicolors <- grDevices::colorRampPalette(rev(RColorBrewer::brewer.pal(9, "Set1")))(28)
ggplot2::ggplot(vGenes, aes(x = samples, y = frequencyGene, fill = familyName)) +
  geom_bar(stat = "identity") +
  theme_minimal() + 
  scale_y_continuous(expand = c(0, 0)) + 
  guides(fill = guide_legend(ncol = 2)) +
  scale_fill_manual(values = multicolors) + 
  labs(y = "Frequency (%)", x = "", fill = "") +
  theme(axis.text.x = element_text(angle = 90, vjust = 0.5, hjust = 1))

## ----comment = ""-------------------------------------------------------------
searchSeq(list = productive.TRB.aa, sequence = "CASSESAGSTGELFF")
cleansed <- removeSeq(file.list = productive.TRB.aa, sequence = "CASSESAGSTGELFF")
searchSeq(list = cleansed, sequence = "CASSESAGSTGELFF")

## -----------------------------------------------------------------------------
TRB_949_Merged <- mergeFiles(samples = c("TRB_CD4_949", "TRB_CD8_949"), 
                                file.list = TCRB.list)

## -----------------------------------------------------------------------------
sessionInfo()

#' Read ImmunoSeq files
#' 
#' Imports tab-separated value (.tsv) files exported by the Adaptive 
#' Biotechnologies ImmunoSEQ analyzer and stores them as a list of data frames.
#' 
#' @param path Path to the directory containing tab-delimited files.  Only 
#' files with the extension .tsv are imported.  The names of the data frames are 
#' the same as names of the files.
#' @param columns Column names from the tab-delimited files that you desire to 
#' import, all others will be disregarded.  May use "all" to import all columns.  
#' A warning may be called if columns contain no data or must be coereced to a 
#' different class.  Usually this warning can be ignored.
#' @param recursive A Boolean value indicating whether tab-delimited files in 
#' subdirectories should be imported.  If TRUE, then all files in the parent as 
#' well as the subdirectory are imported.  If FALSE, then only files in the 
#' parent directory are imported.
#' @details May import tab-delimited files containing antigen receptor 
#' sequencing from other sources (e.g. miTCR or miXCR) as long as the column 
#' names are the same as used by ImmunoSEQ files.  Available column headings in 
#' ImmunoSEQ files are:  
#' "nucleotide", "aminoAcid", "count", "count (templates)", "count (reads)", 
#' "count (templates/reads)", "frequencyCount", "frequencyCount (\%)", "cdr3Length", 
#' "vMaxResolved", "vFamilyName", "vGeneName", "vGeneAllele", "vFamilyTies", 
#' "vGeneNameTies", "vGeneAlleleTies", "dMaxResolved", "dFamilyName", "dGeneName", 
#' "dGeneAllele", "dFamilyTies", "dGeneNameTies", "dGeneAlleleTies", "jMaxResolved", 
#' "jFamilyName", "jGeneName", "jGeneAllele", "jFamilyTies", "jGeneNameTies", 
#' "jGeneAlleleTies", "vDeletion", "d5Deletion", "d3Deletion", "jDeletion", 
#' "n2Insertion", "n1Insertion", "vIndex", "n2Index", "dIndex", "n1Index", 
#' "jIndex", "estimatedNumberGenomes", "sequenceStatus", "cloneResolved", 
#' "vOrphon", "dOrphon", "jOrphon", "vFunction", "dFunction", "jFunction", 
#' "fractionNucleated".  
#'  
#' IMPORTANT: be aware that Adaptive has changed the 
#' column names of their files over time and if the headings of your files are 
#' inconsistent, then specify column = "all" or include all variations of the 
#' headings you want to important.  For example, column = c("count", 
#' "count (templates)", "count (reads)").  Also be aware that the "count" 
#' column previously reported the number of sequencing reads in earlier 
#' versions of ImmunoSEQ but now is equivalent to the 
#' "estimatedNumberGenomes" column.
#' @return Returns a list of data frames.  The names of each data frame are
#' assigned according to the original ImmunoSEQ file names.
#' @examples
#' file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")
#' 
#' file.list <- readImmunoSeq(path = file.path, 
#'                            columns = c("aminoAcid", "nucleotide", "count", 
#'                                      "count (templates)", "count (reads)", 
#'                                      "count (templates/reads)",
#'                                      "frequencyCount", "frequencyCount (%)", 
#'                                      "estimatedNumberGenomes"), 
#'                            recursive = FALSE)
#' @export
#' @importFrom data.table fread
#' @importFrom plyr llply
readImmunoSeq <- function(path, columns = c("aminoAcid", "nucleotide", "count", 
                                            "count (templates)", "count (reads)", 
                                            "count (templates/reads)",
                                            "frequencyCount", "frequencyCount (%)", 
                                            "estimatedNumberGenomes", "vFamilyName", 
                                            "dFamilyName", "jFamilyName","vGeneName", 
                                            "dGeneName", "jGeneName"), 
                          recursive = FALSE) {
    file.paths1 <- list.files(path, full.names = TRUE, all.files = FALSE, 
                             recursive = recursive, pattern = ".tsv", 
                             include.dirs = FALSE)
    file.info <- file.info(file.paths1)
    file.paths2 <- rownames(file.info)[file.info$size > 0]
    if(!identical(file.paths1,file.paths2)){
        warning("One or more of the files you are trying to import has no sequences and will be ignored.", call. = FALSE)
    }
    if (any(columns == "all")) {
        file.list <- suppressWarnings(plyr::llply(file.paths2, data.table::fread, 
                                 data.table = FALSE, .progress = "text"))
    } else {
        file.list <- suppressWarnings(plyr::llply(file.paths2, data.table::fread, select = columns, 
                                 data.table = FALSE, .progress = "text"))
        if(length(unique(plyr::llply(file.list, ncol))) > 1){
            warning("One or more of the files you are trying to import do not contain all the columns you specified.", call. = FALSE)
        }
    }
    file.names <- gsub(".tsv", "", basename(file.paths2))
    names(file.list) <- file.names
    i <- 1
    for (i in 1:length(file.list)) {
        colnames(file.list[[i]]) <- ifelse(grepl("frequencyCount*", 
                                                 colnames(file.list[[i]])), 
                                           "frequencyCount", 
                                           colnames(file.list[[i]]))
        colnames(file.list[[i]]) <- ifelse(grepl("count*", 
                                                 colnames(file.list[[i]])), 
                                           "count", 
                                           colnames(file.list[[i]]))
    }
    return(file.list)
} 

#' Productive sequences
#' 
#' Remove unproductive CDR3 sequences from a single data frame.
#' 
#' @param sample A data frame consisting of antigen receptor sequencing data.  
#' "aminoAcid", "count", and "frequencyCount" are required columns.
#' @param aggregate Indicates whether the values of "count", "frequencyCount", 
#' and "esimatedNumberGenomes" should be aggregated by amino acid or nucleotide 
#' sequence.  Acceptable values are "aminoAcid" or "nucleotide".  If "aminoAcid" 
#' is selected, then the resulting data frame will have columns corresponding to 
#' "aminoAcid", "count", "frequnecyCount", and "estimatedNumberGenomes" (if this 
#' column is available).  If "nucleotide" is selected then all columns in the 
#' original data frame will be present in the outputted data frame.  The difference in 
#' output is due to the fact that the same amino acid CDR3 sequence may be 
#' encoded by multiple unique nucleotide sequences with differing V, D, and J 
#' genes. 
#' @return Returns a data frame of productive amino acid sequences with recomputed 
#' values for "count", "frequencyCount", and "esimatedNumberGenomes".  A 
#' productive sequences is defined as a sequence that is in frame and does not 
#' have an early stop codon.
#' @examples
#' file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")
#' 
#' file.list <- readImmunoSeq(path = file.path)
#' 
#' productive <- productive(sample = file.list[["TRB_Unsorted_32"]], aggregate = "aminoAcid")
#' @seealso \code{\link{productiveSeq}}
#' @export
#' @importFrom stats aggregate
productive <- function(sample, aggregate = "aminoAcid") {
    productive.seqs <- sample[which(sample[, "aminoAcid"] != "" &
                                        !grepl("\\*", sample[, "aminoAcid"])), ]
    if(nrow(productive.seqs) != 0){
        if (any(grepl("estimatedNumberGenomes", colnames(productive.seqs)))) {
            if (aggregate == "aminoAcid") {
                count <- aggregate(count ~ aminoAcid, data = productive.seqs, FUN = sum)
                productive.seqs$estimatedNumberGenomes <- suppressWarnings(as.integer(productive.seqs$estimatedNumberGenomes))
                productive.seqs$estimatedNumberGenomes[is.na(productive.seqs$estimatedNumberGenomes)] <- 0
                productive.seqs$estimatedNumberGenomes[is.na(as.integer(productive.seqs$estimatedNumberGenomes))] <- 0
                estimatedNumberGenomes <- aggregate(estimatedNumberGenomes ~ aminoAcid, 
                                                    data = productive.seqs, FUN = sum)
                merged <- merge(count, estimatedNumberGenomes, by = "aminoAcid")
                merged$frequencyCount <- merged$count/sum(count$count) * 100
            }
            if (aggregate == "nucleotide") {
                count <- aggregate(count ~ nucleotide, data = productive.seqs, FUN = sum)
                productive.seqs$estimatedNumberGenomes <- suppressWarnings(as.integer(productive.seqs$estimatedNumberGenomes))
                productive.seqs$estimatedNumberGenomes[is.na(productive.seqs$estimatedNumberGenomes)] <- 0
                productive.seqs$estimatedNumberGenomes[is.na(as.integer(productive.seqs$estimatedNumberGenomes))] <- 0
                estimatedNumberGenomes <- aggregate(estimatedNumberGenomes ~ nucleotide, 
                                                    data = productive.seqs, FUN = sum)
                productive.seqs$count <- NULL
                productive.seqs$estimatedNumberGenomes <- NULL
                merged <- Reduce(function(x, y) merge(x, y, by = "nucleotide"), 
                                 list(productive.seqs, count, estimatedNumberGenomes))
                merged$frequencyCount <- merged$count/sum(count$count) * 100
            }
        } else {
            if (aggregate == "aminoAcid") {
                merged <- aggregate(count ~ aminoAcid, data = productive.seqs, FUN = sum)
                merged$frequencyCount <- merged$count/sum(merged$count) * 100
            }
            if (aggregate == "nucleotide") {
                count <- aggregate(count ~ nucleotide, data = productive.seqs, FUN = sum)
                productive.seqs$count <- NULL
                merged <- merge(productive.seqs, count, by = "nucleotide")
                merged$frequencyCount <- merged$count/sum(merged$count) * 100
            }
        }
        merged <- merged[order(merged$frequencyCount, decreasing = TRUE), intersect(names(sample), names(merged))]
        rownames(merged) <- NULL
        return(merged)
    }
} 

#' Cumulative frequency bar plot of top sequences
#' 
#' Create a cumulative frequency bar plot of a specified number of top 
#' sequences.
#' 
#' @param list A list data frames imported using the LymphoSeq function readImmunoSeq 
#' or productiveSeq.
#' @param top The number of top sequences to be colored in the bar plot.  All 
#' other, less frequent sequences are colored violet.
#' @return Returns a cumulative frequency bar plot of the top sequences.
#' @details The plot is made using the package ggplot2 and can be reformatted
#' using ggplot2 functions.  See examples below.
#' @seealso An excellent resource for examples on how to reformat a ggplot can 
#' be found in the R Graphics Cookbook online (\url{http://www.cookbook-r.com/Graphs/}).
#' @examples
#' file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")
#' 
#' file.list <- readImmunoSeq(path = file.path)
#' 
#' productive.aa <- productiveSeq(file.list = file.list, aggregate = "aminoAcid")
#' 
#' topSeqsPlot(list = productive.aa, top = 10)
#' 
#' # Display the number of sequences at the top of bar plot and add a title
#' n <- as.character(lapply(file.list, nrow))
#' 
#' topSeqsPlot(list = productive.aa, top = 10) + 
#'    ggplot2::annotate("text", x = 1:length(file.list), y = 105, label = n, color = "black") +
#'    ggplot2::expand_limits(y = c(0, 110)) + ggplot2::ggtitle("Figure Title") + 
#'    ggplot2::scale_x_discrete(limits = names(file.list))
#' @export
#' @import ggplot2
#' @importFrom RColorBrewer brewer.pal
#' @importFrom plyr llply
topSeqsPlot <- function(list, top = 10) {
    if (any(top > lapply(list, nrow))) {
        stop(paste("The value for 'top' must be less than the smallest number of sequences in your data set (", min(unlist(lapply(list, nrow))), ")", sep = ""))
    }
    dominant <- plyr::llply(list, function(x) 
        x$frequencyCount[order(x$frequencyCount, decreasing = TRUE)][1:top])
    aminoAcid <- plyr::llply(list, function(x) 
        x$aminoAcid[order(x$frequencyCount, decreasing = TRUE)][1:top])
    subdominant <- plyr::llply(dominant, function(x) 100 - sum(x))

    dominant.df <- plyr::ldply(dominant, data.frame)
    aminoAcid.df <- plyr::ldply(aminoAcid, data.frame)
    subdominant.df <- plyr::ldply(subdominant, data.frame)
    
    dominant.df$aminoAcid <- aminoAcid.df$X..i..
    subdominant.df$aminoAcid <- rep("All other sequences", nrow(subdominant.df))
    topfreq <- rbind(dominant.df,subdominant.df)
    
    colnames(topfreq) <- c("Sample", "Frequency", "aminoAcid")
    topfreq$Sequence <- factor(paste("Sequence", c(rep(1:top, length(list)), 
                                                   rep(top + 1, length(list)))))
    topfreq$Sequence <- factor(topfreq$Sequence, 
                               levels = paste("Sequence", 1:(top + 1)))
    x.order <- names(subdominant[order(topfreq[topfreq$Sequence == paste("Sequence", top + 1), "Frequency"])])
    topfreq$CumulativeFrequency = topfreq$Frequency
    getPalette <- grDevices::colorRampPalette(RColorBrewer::brewer.pal(11, "Spectral"))
    ggplot(topfreq, aes_string(x = "Sample", y = "CumulativeFrequency", fill = "Sequence", label = "Frequency", text = "aminoAcid")) + 
        geom_bar(stat = "identity") + 
        scale_x_discrete(limits = x.order) + 
        scale_fill_manual(values = getPalette(top + 1)) + 
        theme_classic() + 
        scale_y_continuous(expand = c(0, 0)) + 
        theme(legend.position = "none") + 
        theme(axis.text.x = element_text(angle = 90, vjust = 0.5, hjust = 1, size = 10), 
              axis.text.y = element_text(size = 10)) + labs(x = "", y = "Frequency (%)")
} 

---
title: "Analysis of high-throughput sequencing of T and B cell receptors with LymphoSeq"
author: "David G. Coffey, MD"
date: "April 14, 2017"
output: 
    html_document:
        toc: true
        toc_float: true
        theme: cosmo
        highlight: default
        df_print: paged
vignette: >
    %\VignetteIndexEntry{Analysis of high-throughput sequencing of T and B cell receptors with LymphoSeq}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
---

Application of high-throughput sequencing of T and B lymphocyte antigen receptors has great potential for improving the monitoring of lymphoid malignancies, assessing immune reconstitution after hematopoietic stem cell transplantation, and characterizing the composition of lymphocyte repertoires [(Warren, E. H. *et al. Blood* 2013;122:19–22)](https://www.ncbi.nlm.nih.gov/pubmed/?term=23656731).   LymhoSeq is an R package designed to import, analyze, and visualize antigen receptor sequencing from [Adaptive Biotechnologies' ImmunoSEQ assay](http://www.adaptivebiotech.com/immunoseq).  The package is also adaptable to the analysis of T and B cell receptor sequencing processed using other platforms such as [MiXCR](https://milaboratory.com/software/mixcr/) or [IMGT/HighV-QUEST](http://www.imgt.org/HighV-QUEST/login.action).  This vignette has been written to highlight some of the features of LymphoSeq and guide the user through a typical workflow.

## Importing data
The LymphoSeq function `readImmunoSeq` imports tab-separated value (`.tsv`) files exported by Adaptive Biotechnologies ImmunoSEQ analyzer v2 where each row represents a unique sequence and each column is a variable with information about that sequence such as read count, frequency, or variable gene name.  **Note that the file format for ImmunoSEQ analyzer v3 is not yet supported and users must choose to export the v2 format from the analyzer software.**  Only files with the extension `.tsv` are imported while all other are disregarded.  It is possible to import files processed using other platforms as long as the files are tab-delimited, are given the extension `.tsv` and have identical column names as the ImmunoSEQs files (see `readImmunoSeq` manual for a list of column names used by this file type).  Refer to the LymphoSeq manual regarding the required column names used by each function.

To explore the features of LymphoSeq, this package includes 2 example data sets.  The first is a data set of T cell receptor beta (TCRB) sequencing from 10 blood samples acquired serially from a single patient who underwent a bone marrow transplant [(Kanakry, C.G., *et al. JCI Insight* 2016;1(5):pii: e86252)](https://www.ncbi.nlm.nih.gov/pubmed/?term=27213183).  The second, is a data set of B cell receptor immunoglobulin heavy (IGH) chain sequencing from Burkitt lymphoma tumor biopsies acquired from 10 different individuals [(Lombardo, K.A., *et al. Blood Advances* 2017 1:535-544)](http://www.bloodadvances.org/content/1/9/535).  To improve performance, both data sets contain only the top 1,000 most frequent sequences.  The complete data sets are publicly available through [Adapatives' immuneACCESS portal](https://clients.adaptivebiotech.com/immuneaccess).  As shown in the example below, you can specify the path to the example data sets using the command `system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")` for the TCRB  files and `system.file("extdata", "IGH_sequencing", package = "LymphoSeq")` for the IGH files.

`readImmunoSeq` imports each file in the specified directory as a list object where each file becomes a data frame.  You can import all columns from each file by setting the `columns` parameter to `"all"` or list just those columns of interest.  Be aware that Adaptive Biotechnologies has changed the column names of their files over time and if the headings of your files are not all the same, you will need to specify `"all"` or provide all variations of the column header.  By default, the `columns` parameter is set to import only those columns used by LymphoSeq.

```{r, results = "hide"}
library(LymphoSeq)

TCRB.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")

TCRB.list <- readImmunoSeq(path = TCRB.path)
```

Notice that each data frame listed in the `TCRB.list` object is named according the ImmunoSEQ file names.  If different names are desired, you may rename the original `.tsv` files or assign `names(TCRB.list)` to a new character vector of desired names in the same order as the list.

```{r, comment = ""}
names(TCRB.list)
```

Having the data in the form of a list makes it easy to apply a function over that list using the base function `lapply`.  For example, you may use the function `dim` to report the dimensions of each data frame as shown below.  Noticed that each data frame in the example below has less than 1,000 rows and 11 columns.

``` {r, comment = ""}
lapply(TCRB.list, dim)
```

In place of `dim`, you may also use `colnames`, `nrow`, `ncol`, or other more complex functions that perform operations on subsetted columns.

## Subsetting data
If you imported all of the files from your project but just want to perform an analysis on a subset, use standard R methods to subset the list.  Remember that a single bracket `[` returns a list and a double bracket `[[` returns a single data frame.

```{r, comment = ""}
CMV <- TCRB.list[grep("CMV", names(TCRB.list))]
names(CMV)
TRB_Unsorted_0 <- TCRB.list[["TRB_Unsorted_0"]]
head(TRB_Unsorted_0)
```

For more complex subsetting, you can use a metadata file where one column contains the file names and the other columns have additional information about the sample files.  You can then subset the metadata file using criteria from the other columns to give you just a character vector of file names that you can use to subset TCRB.list.  In the example below, a metadata file is imported for the example TCRB data set which contains information on the number of days post bone marrow transplant the sample was collected and the cellular phenopyte the blood sample was sorted for prior to sequencing.

```{r, comment = ""}
TCRB.metadata <- read.csv(system.file("extdata", "TCRB_metadata.csv", package = "LymphoSeq"))
TCRB.metadata
selected <- as.character(TCRB.metadata[TCRB.metadata$phenotype == "Unsorted" & 
                                 TCRB.metadata$day > 300, "samples"])
TCRB.list.selected <- TCRB.list[selected]
names(TCRB.list.selected)
```

## Extracting productive sequences
A productive sequence is defined as a sequences that is in frame and does not have an early stop codon.  If you sequenced genomic DNA as opposed to complimentary DNA made from RNA, then you will have unproductive and productive sequences in your data files.  Use the function `productiveSeq` to remove unproductive sequences and recompute the frequencyCount for each of your samples.

If you are interested in just the complementarity determining region 3 (CDR3) amino acid sequences, then set aggregate to `"aminoAcid"` and the count and estimated number of genomes for duplicate amino acid sequences will be summed.  Note that the resulting list of data frames will have columns corresponding to "aminoAcid", "count", "frequencyCount", and "estimatedNumberGenomes" (if this column is available) only.  All other columns, such as those corresponding to the V, D, and J gene names, will be removed if they were included in your original file list.  The reason for this is to avoid confusion since a single amino acid CDR3 sequence may be encoded by multiple different nucleotide sequences with differing V, D, and J genes.

```{r, results = "hide"}
productive.TRB.aa <- productiveSeq(file.list = TCRB.list, aggregate = "aminoAcid", 
                               prevalence = FALSE)
```

Alternatively, you may set aggregate to `"nucleotide"` and the resulting list of data frames will all have the same columns as your original file list.  Take note that some LymphoSeq functions require a productive sequence list aggregated by amino acid or nucleotide.

```{r, results = "hide"}
productive.TRB.nt <- productiveSeq(file.list = TCRB.list, aggregate = "nucleotide", 
                               prevalence = FALSE)
```

If the parameter `prevalence` is set to `TRUE`, then a new column is added to each of the data frames giving the prevalence (%) of each TCR beta CDR3 amino acid sequence in 55 healthy donor peripheral blood samples.  Values range from 0 to 100% where 100% means the sequence appeared in the blood of all 55 individuals.  The data for this operation resides in a separate package that is automatically loaded called LymphoSeqDB.  Please refer to that package manual for more details.

Notice in the example below that there are no amino acid sequences given in the first and fourth row of the TCRB.list data frame for sample "TRB_Unsorted_949".  This is because the nucleotide sequence is out of frame and does not produce a productively transcribed amino acid sequence.  If an asterisk (*) appears in the amino acid sequences, this would indicate an early stop codon.

```{r, comment = ""}
head(TCRB.list[["TRB_Unsorted_0"]])
```

After `productiveSeq` is run, the unproductive sequences are removed and the frequencyCount is recalculated for each sequence.  If there were two identical amino acid sequences that differed in their nucleotide sequence, they would be combined and their counts added together. 

```{r, comment = ""}
head(productive.TRB.aa[["TRB_Unsorted_0"]])
```

Finally, notice that the productive.TRB.nt data frame for sample "TRB_Unsorted_949" below has additional columns not present in productive.TRB.aa but are in TCRB.list.  This is because the data frame was aggregated by nucleotide sequence and all of the original columns from TCRB.list were carried over.

```{r, comment = ""}
head(productive.TRB.nt[["TRB_Unsorted_0"]])
```

## Create a table of summary statistics
To create a table summarizing the total number of sequences, number of unique productive sequences, number of genomes, entropy, clonality, Gini coefficient, and the frequency (%) of the top productive sequence in each imported file, use the function `clonality`.

```{r, comment = ""}
clonality(file.list = TCRB.list)
```

The clonality score is derived from the Shannon entropy, which is calculated from the frequencies of all productive sequences divided by the logarithm of the total number of unique productive sequences. This normalized entropy value is then inverted (1 - normalized entropy) to produce the clonality metric.

The [Gini coefficient](https://en.wikipedia.org/wiki/Gini_coefficient) is an alternative metric used to calculate repertoire diversity and is derived from the [Lorenz curve](https://en.wikipedia.org/wiki/Lorenz_curve). The Lorenz curve is drawn such that x-axis represents the cumulative percentage of unique sequences and the y-axis represents the cumulative percentage of reads. A line passing through the origin with a slope of 1 reflects equal frequencies of all clones. The Gini coefficient is the ratio of the area between the line of equality and the observed Lorenz curve over the total area under the line of equality. 

Both Gini coefficient and clonality are reported on a scale from 0 to 1 where 0 indicates all sequences have the same frequency and 1 indicates the repertoire is dominated by a single sequence.

## Calculate clonal relatedness
One of the drawbacks of the clonality metric is that it does not take into account sequence similarity.  This is particularly important when studying affinity maturation or B cell malignancies[(Lombardo, K.A., *et al. Blood Advances* 2017 1:535-544)](http://www.bloodadvances.org/content/1/9/535). Clonal relatedness is a useful metric that takes into account sequence similarity without regard for clonal frequency.  It is defined as the proportion of nucleotide sequences that are related by a defined edit distance threshold. The value ranges from 0 to 1 where 0 indicates no sequences are related and 1 indicates all sequences are related.  Edit distance is a way of quantifying how dissimilar two sequences are to one another by counting the minimum number of operations required to transform one sequence into the other. For example, an edit distance of 0 means the sequences are identical and an edit distance of 1 indicates that the sequences different by a single amino acid or nucleotide.

```{r, results = "hide"}
IGH.path <- system.file("extdata", "IGH_sequencing", package = "LymphoSeq")

IGH.list <- readImmunoSeq(path = IGH.path)
```
```{r, comment = ""}
clonalRelatedness(list = IGH.list, editDistance = 10)
```

## Draw a phylogenetic tree
A phylogenetic tree is a useful way to visualize the similarity between sequences.  The `phyloTree` function create a phylogenetic tree of a single sample using neighbor joining tree estimation for amino acid or nucleotide CDR3 sequences.  Each leaf in the tree represents a sequence color coded by the V, D, and J gene usage. The number next to each leaf refers to the sequence count. A triangle shaped leaf indicates the most frequent sequence.  The distance between leaves on the horizontal axis corresponds to the sequence similarity (i.e. the further apart the leaves are horizontally, the less similar the sequences are to one another).

```{r, results = "hide"}
productive.IGH.nt <- productiveSeq(file.list = IGH.list, aggregate = "nucleotide")
```

```{r, fig.width = 7, fig.height = 8, comment = ""}
phyloTree(list = productive.IGH.nt, sample = "IGH_MVQ92552A_BL", type = "nucleotide", 
         layout = "rectangular")
```

## Multiple sequence alignment
In LymphoSeq, you can perform a multiple sequence alignment using one of three methods provided by the Bioconductor msa package (ClustalW, ClustalOmega, or Muscle) and output results to the console or as a pdf file. One may perform the alignment of all amino acid or nucleotide sequences in a single sample.  Alternatively, one may search for a given sequence within a list of samples using an edit distance threshold.

```{r, comment = ""}
alignSeq(list = productive.IGH.nt, sample = "IGH_MVQ92552A_BL", type = "aminoAcid", 
         method = "ClustalW", output = "consule")
```

## Searching for sequences
To search for one or more amino acid or nucleotide CDR3 sequences in a list of data frames, use the function `searchSeq`.  You may specify to search in either a list of productive or unproductive data frames.

```{r, comment = ""}
searchSeq(list = productive.TRB.aa, sequence = "CASSPVSNEQFF", type = "aminoAcid", 
          match = "global", editDistance = 0)
```

If you have only a partial sequence, set the parameter match to `"partial"`.  If you are looking for related sequences that differ by one or more nucleotides or amino acids, then increase the `editDistance` value.  Edit distance is a way of quantifying how dissimilar two sequences are to one another by counting the minimum number of operations required to transform one sequence into the other. For example, an edit distance of 0 means the sequences are identical and an edit distance of 1 indicates that the sequences differ by a single amino acid or nucleotide.

## Searching for published sequences
To search your entire list of data frames for a published amino acid CDR3 TCRB sequence with known antigen specificity, use the function `searchPublished`.

```{r, comment = ""}
published <- searchPublished(list = productive.TRB.aa)
head(published)
```

For each found sequence, a table is provides listing the antigen, epitope, HLA type, PubMed ID (PMID), and prevalence (%) of the sequence among 55 healthy donor blood samples.  The data for this function resides in the separate LymphoSeqDB package that is automatically loaded when the function is called.  Please refer to that package manual for more details.

## Visualizing repertoire diversity
Antigen receptor repertoire diversity can be characterized by a number such as clonality or Gini coefficient calculated by the `clonality` function.  Alternatively, you can visualize the repertoire diversity by plotting the Lorenz curve for each sample as defined above.  In this plot, the more diverse samples will appear near the dotted diagonal line (the line of equality) whereas the more clonal samples will appear to have a more bowed shape.

```{r, fig.width = 7, fig.height = 7, comment = ""}
lorenzCurve(samples = names(productive.TRB.aa), list = productive.TRB.aa)
```

Alternatively, you can get a feel for the repertoire diversity by plotting the cumulative frequency of a selected number of the top most frequent clones using the function `topSeqsPlot`.  In this case, each of the top sequences are represented by a different color and all less frequent clones will be assigned a single color (violet).

```{r, fig.width = 7, fig.height = 5, comment = ""}
topSeqsPlot(list = productive.TRB.aa, top = 10)
```


Both of these functions are built using the [ggplot2 package](http://docs.ggplot2.org/current/).  You can reformat the plot using ggplot2 functions.  Please refer to the `lorenzCurve` and `topSeqsPlot` manual for specific examples.

## Comparing samples
To compare the T or B cell repertoires of all samples in a pairwise fashion, use the `bhattacharyyaMatrix` or `similarityMatrix` functions.  Both the Bhattacharyya coefficient and similarity score are measures of the amount of overlap between two samples.  The value for each ranges from 0 to 1 where 1 indicates the sequence frequencies are identical in the two samples and 0 indicates no shared frequencies.  The Bhattacharyya coefficient differs from the similarity score in that it involves weighting each shared sequence in the two distributions by the arithmetic mean of the frequency of each sequence, while calculating the similarity scores involves weighting each shared sequence in the two distributions by the geometric mean of the frequency of each sequence in the two distributions.

```{r, comment = ""}
bhattacharyya.matrix <- bhattacharyyaMatrix(productive.seqs = productive.TRB.aa)
bhattacharyya.matrix
similarity.matrix <- similarityMatrix(productive.seqs = productive.TRB.aa)
similarity.matrix
```

The results of either function can be visualized by the `pairwisePlot` function.

```{r, fig.width = 6.5, fig.height = 5, comment = ""}
pairwisePlot(matrix = bhattacharyya.matrix)
```

To view sequences shared between two or more samples, use the function `commonSeqs`.  This function requires that a productive amino acid list be specified.
```{r, comment = ""}
common <- commonSeqs(samples = c("TRB_Unsorted_0", "TRB_Unsorted_32"), 
                    productive.aa = productive.TRB.aa)
head(common)
```

To visualize the number of overlapping sequences between two or three samples in the form of a Venn diagram, use the function `commonSeqVenn`.

```{r, fig.width = 4, fig.height = 4, comment = ""}
commonSeqsVenn(samples = c("TRB_Unsorted_32", "TRB_Unsorted_83"), 
               productive.seqs = productive.TRB.aa)
```

```{r, fig.width = 4, fig.height = 4, comment = ""}
commonSeqsVenn(samples = c("TRB_Unsorted_0", "TRB_Unsorted_32", "TRB_Unsorted_83"), 
               productive.seqs = productive.TRB.aa)
```

To compare the frequency of sequences between two samples as a scatter plot, use the function `commonSeqsPlot`.

```{r, fig.width = 4, fig.height = 4, comment = ""}
commonSeqsPlot("TRB_Unsorted_32", "TRB_Unsorted_83", 
               productive.aa = productive.TRB.aa, show = "common")
```

If you have more than 3 samples to compare, use the `commonSeqBar` function.  You can chose to color a single sample with the `color.sample` argument or a desired intersection with the `color.intersection` argument.

```{r, fig.width = 7, fig.height = 5, comment = ""}
commonSeqsBar(productive.aa = productive.TRB.aa, 
              samples = c("TRB_CD4_949", "TRB_CD8_949", 
                          "TRB_Unsorted_949", "TRB_Unsorted_1320"), 
              color.sample = "TRB_CD8_949",
              labels = "no")
```

## Differential abundance
When comparing a sample from two different time points, it is useful to identify sequences that are significantly more or less abundant in one versus the other time point [(DeWitt, W.S., *et al. Journal of Virology* 2015 89(8):4517-4526)](https://www.ncbi.nlm.nih.gov/pubmed/25653453).  The `differentialAbundance` function uses a Fisher exact test to calculate differential abundance of each sequence in two time points and reports the log2 transformed fold change, P value and adjusted P value.

```{r, comment = "", warning = FALSE}
differentialAbundance(list = productive.TRB.aa, 
                      sample1 = "TRB_Unsorted_949", 
                      sample2 = "TRB_Unsorted_1320", 
                      type = "aminoAcid", q = 0.01)
```

## Finding recurring sequences
To create a data frame of unique, productive amino acid sequences as rows and sample names as headers use the `seqMatrix` function.  Each value in the data frame represents the frequency that each sequence appears in the sample.  You can specify your own list of sequences or all unique sequences in the list using the output of the function `uniqueSeqs`.  The `uniqueSeqs` function creates a data frame of all unique, productive sequences and reports the total count in all samples.

```{r, comment = ""}
unique.seqs <- uniqueSeqs(productive.aa = productive.TRB.aa)
head(unique.seqs)
sequence.matrix <- seqMatrix(productive.aa = productive.TRB.aa, sequences = unique.seqs$aminoAcid)
head(sequence.matrix)
```

If just the top clones with a frequency greater than a specified amount are of interest to you, then use the `topFreq` function.  This creates a data frame of the top productive amino acid sequences having a minimum specified frequency and reports the minimum, maximum, and mean frequency that the sequence appears in a list of samples. For TCRB sequences, the prevalence (%) and the published antigen specificity of that sequence are also provided.

```{r, comment = ""}
top.freq <- topFreq(productive.aa = productive.TRB.aa, percent = 0.1)
head(top.freq)
```

One very useful thing to do is merge the output of `seqMatrix` and `topFreq`.

```{r, comment = ""}
top.freq <- topFreq(productive.aa = productive.TRB.aa, percent = 0)
top.freq.matrix <- merge(top.freq, sequence.matrix)
head(top.freq.matrix)
```

## Tracking sequences across samples
To visually track the frequency of sequences across multiple samples, use the function `cloneTrack`.  This function takes the output from the `seqMatrix` function.  You can specify a character vector of amino acid sequences using the parameter `track` to highlight those sequences with a different color.  Alternatively, you can highlight all of the sequences from a given sample using the parameter `map`.  If the mapping feature is use, then you must specify a productive amino acid list and a character vector of labels to title the mapped samples.  To hide sequences that are not being tracked or mapped, set `unassigned` to FALSE.

```{r, fig.width = 7, fig.height = 5}
cloneTrack(sequence.matrix = sequence.matrix, 
           productive.aa = productive.TRB.aa, 
           map = c("TRB_CD4_949", "TRB_CD8_949"), 
           label = c("CD4", "CD8"), 
           track = "CASSPPTGERDTQYF", 
           unassigned = FALSE)
```

Refer to the `cloneTrack` manual for examples on how to reformat the chart using ggplot2 function.

## Comparing V(D)J gene usage
To compare the V, D, and J gene usage across samples, start by creating a data frame of V, D, and J gene counts and frequencies using the function `geneFreq`.  You can specify if you are interested in the "VDJ", "DJ", "VJ", "DJ", "V", "D", or "J" loci using the `locus` parameter.  Set `family` to TRUE if you prefer the family names instead of the gene names as reported by ImmunoSeq.

```{r, comment = ""}
vGenes <- geneFreq(productive.nt = productive.TRB.nt, locus = "V", family = TRUE)
head(vGenes)
```

To create a chord diagram showing VJ or DJ gene associations from one or more more samples, combine the output of `geneFreq` with the function `chordDiagramVDJ`.  This function works well the `topSeqs` function that creates a data frame of a selected number of top productive sequences.  In the example below, a chord diagram is made showing the association between V and J genes of just the single dominant clones in each sample.  The size of the ribbons connecting VJ genes correspond to the number of samples that have that recombination event. The thicker the ribbon, the higher the frequency of the recombination.

```{r, fig.width = 4, fig.height = 4}
top.seqs <- topSeqs(productive.seqs = productive.TRB.nt, top = 1)
chordDiagramVDJ(sample = top.seqs, 
                association = "VJ", 
                colors = c("darkred", "navyblue"))
```


You can also visualize the results of `geneFreq` as a heat map, word cloud, our cumulative frequency bar plot with the support of additional R packages as shown below.

```{r, fig.width = 4, fig.height = 4, warning = FALSE, message = FALSE}
vGenes <- geneFreq(productive.nt = productive.TRB.nt, locus = "V", family = TRUE)
library(RColorBrewer)
library(grDevices)
RedBlue <- grDevices::colorRampPalette(rev(RColorBrewer::brewer.pal(11, "RdBu")))(256)
library(wordcloud)
wordcloud::wordcloud(words = vGenes[vGenes$samples == "TRB_Unsorted_83", "familyName"], 
                     freq = vGenes[vGenes$samples == "TRB_Unsorted_83", "frequencyGene"], 
                     colors = RedBlue)
```

```{r, fig.width = 5, fig.height = 7, warning = FALSE, message = FALSE}
library(reshape)
vGenes <- reshape::cast(vGenes, familyName ~ samples, value = "frequencyGene", sum)
rownames(vGenes) = as.character(vGenes$familyName)
vGenes$familyName = NULL
library(pheatmap)
pheatmap::pheatmap(vGenes, color = RedBlue, scale = "row")
```

```{r, fig.width = 7, fig.height = 5.6, warning = FALSE, message = FALSE}
vGenes <- geneFreq(productive.nt = productive.TRB.nt, locus = "V", family = TRUE)
library(ggplot2)
multicolors <- grDevices::colorRampPalette(rev(RColorBrewer::brewer.pal(9, "Set1")))(28)
ggplot2::ggplot(vGenes, aes(x = samples, y = frequencyGene, fill = familyName)) +
  geom_bar(stat = "identity") +
  theme_minimal() + 
  scale_y_continuous(expand = c(0, 0)) + 
  guides(fill = guide_legend(ncol = 2)) +
  scale_fill_manual(values = multicolors) + 
  labs(y = "Frequency (%)", x = "", fill = "") +
  theme(axis.text.x = element_text(angle = 90, vjust = 0.5, hjust = 1))
```


## Removing sequences
Occasionally you may identify one or more sequences in your data set that appear to be contamination.  You can remove an amino acid sequence from all data frames using the function `removeSeq` and recompute frequencyCount for all remaining sequences.

```{r, comment = ""}
searchSeq(list = productive.TRB.aa, sequence = "CASSESAGSTGELFF")
cleansed <- removeSeq(file.list = productive.TRB.aa, sequence = "CASSESAGSTGELFF")
searchSeq(list = cleansed, sequence = "CASSESAGSTGELFF")
```

## Merging samples
If you need to combine multiple samples into one, use the `mergeFiles` function.  It merges two or more sample data frames into a single data frame and aggregates count, frequencyCount, and estimatedNumberGenomes.

```{r}
TRB_949_Merged <- mergeFiles(samples = c("TRB_CD4_949", "TRB_CD8_949"), 
                                file.list = TCRB.list)
```

## Conclusion
Advances in high-throughput sequencing have enabled characterizing T and B lymphocyte repertoires with unprecedented depth.  LymphoSeq was developed as a tool to assist in the analysis of targeted next generation sequencing of the hypervariable CDR3 region of T and B cell receptors.  The three key features of this R package are to characterize lymphocyte repertoire diversity, compare two or more lymphocyte repertoires, and track the frequency of CDR3 sequences across multiple samples.  LymphoSeq also provides the unique ability to search for sequences in a curated database of published TCRB sequences with known antigen specificity.  Finally, LymphoSeq can assign the percent prevalence that any given TCRB sequence appears in a the peripheral blood in healthy population of donors.

## Session info
```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/commonSeqsBar.R
\name{commonSeqsBar}
\alias{commonSeqsBar}
\title{Common sequences bar plot}
\usage{
commonSeqsBar(productive.aa, samples, color.sample = NULL,
  color.intersection = NULL, color = "#377eb8", labels = "no")
}
\arguments{
\item{productive.aa}{A list data frames of of productive amino acid sequences 
generated by LymphoSeq function productiveSeq where the aggregate parameter 
was set to "aminoAcid".}

\item{samples}{The names of two or more samples in the productive.aa 
list whose intersections will shown.}

\item{color.sample}{The name of a single sample in the productive.aa list whose 
sequences will be colored in all samples that they appear in.}

\item{color.intersection}{The names of two or more samples in the productive.aa 
list whose intersections will be colored.}

\item{color}{A character vector of a color name that will be used highlight a selected 
sample or multiple sample intersections.}

\item{labels}{A character vector indicating whether the number of 
intersecting sequences should be shown on the tops of the bars.  Options 
include "yes" or "no".}
}
\value{
Returns an UpSetR bar plot showing the number of intersecting sequences 
across multiple samples.
}
\description{
Creates an UpSetR bar plot showing the number of intersecting sequences across 
multiple samples.  This function is useful when more than 3 samples are being 
compared.
}
\examples{
file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")

file.list <- readImmunoSeq(path = file.path)

productive.aa <- productiveSeq(file.list = file.list, aggregate = "aminoAcid")

commonSeqsBar(productive.aa = productive.aa, samples = c("TRB_CD4_949", "TRB_CD8_949", 
"TRB_Unsorted_949", "TRB_Unsorted_1320"), color.sample = "TRB_CD8_949")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/productive.R
\name{productive}
\alias{productive}
\title{Productive sequences}
\usage{
productive(sample, aggregate = "aminoAcid")
}
\arguments{
\item{sample}{A data frame consisting of antigen receptor sequencing data.
"aminoAcid", "count", and "frequencyCount" are required columns.}

\item{aggregate}{Indicates whether the values of "count", "frequencyCount", 
and "esimatedNumberGenomes" should be aggregated by amino acid or nucleotide 
sequence.  Acceptable values are "aminoAcid" or "nucleotide".  If "aminoAcid" 
is selected, then the resulting data frame will have columns corresponding to 
"aminoAcid", "count", "frequnecyCount", and "estimatedNumberGenomes" (if this 
column is available).  If "nucleotide" is selected then all columns in the 
original data frame will be present in the outputted data frame.  The difference in 
output is due to the fact that the same amino acid CDR3 sequence may be 
encoded by multiple unique nucleotide sequences with differing V, D, and J 
genes.}
}
\value{
Returns a data frame of productive amino acid sequences with recomputed 
values for "count", "frequencyCount", and "esimatedNumberGenomes".  A 
productive sequences is defined as a sequence that is in frame and does not 
have an early stop codon.
}
\description{
Remove unproductive CDR3 sequences from a single data frame.
}
\examples{
file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")

file.list <- readImmunoSeq(path = file.path)

productive <- productive(sample = file.list[["TRB_Unsorted_32"]], aggregate = "aminoAcid")
}
\seealso{
\code{\link{productiveSeq}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chordDiagramVDJ.R
\name{chordDiagramVDJ}
\alias{chordDiagramVDJ}
\title{Chord diagram of VJ or DJ gene associations}
\usage{
chordDiagramVDJ(sample, association = "VJ", colors = c("red", "blue"))
}
\arguments{
\item{sample}{A data frame consisting of frequencies of antigen receptor 
sequences.  "vFamilyName", "jFamilyName", and if applicable, "dFamilyName" 
are a required columns.  Using output from the LymphoSeq function topSeqs is
recommended.}

\item{association}{A character vector of gene familes to associate.  Options 
include "VJ" or "DJ".}

\item{colors}{A character vector of 2 colors corresponding to the V/D and J 
gene colors respectively.}
}
\value{
Returns a chord diagram showing VJ or DJ gene associations from one or 
more samples.
}
\description{
Creates a chord diagram showing VJ or DJ gene associations from one or more 
samples.
}
\details{
The size of the ribbons connecting VJ or DJ genes correspond to the 
number of samples or number of sequences that make up that recombination 
event.  The thicker the ribbon, the higher the frequency of the recombination.
}
\examples{
file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")

file.list <- readImmunoSeq(path = file.path)

productive.nt <- productiveSeq(file.list = file.list, aggregate = "nucleotide")

top.seqs <- topSeqs(productive.seqs = productive.nt, top = 1)

chordDiagramVDJ(sample = top.seqs, association = "VJ", colors = c("red", "blue"))

# Remove "TCRB" from gene family name
top.seqs <- as.data.frame(apply(top.seqs, 2, function(x) gsub("TCRB", "", x)))

chordDiagramVDJ(sample = top.seqs, association = "VJ", colors = c("red", "blue"))
}
\seealso{
\code{\link{topSeqs}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bhattacharyyaMatrix.R
\name{bhattacharyyaMatrix}
\alias{bhattacharyyaMatrix}
\title{Bhattacharyya matrix}
\usage{
bhattacharyyaMatrix(productive.seqs)
}
\arguments{
\item{productive.seqs}{A list data frames of productive sequences generated 
by the LymphoSeq function productiveSeq.  "frequencyCount" and "aminoAcid" 
are a required columns.}
}
\value{
A data frame of Bhattacharyya coefficients calculated from all 
pairwise comparisons from a list of sample data frames.  The Bhattacharyya 
coefficient is a measure of the amount of overlap between two samples.  The 
value ranges from 0 to 1 where 1 indicates the sequence frequencies are 
identical in the two samples and 0 indicates no shared frequencies.
}
\description{
Calculates the Bhattacharyya coefficient of all pairwise comparison from a 
list of data frames.
}
\examples{
file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")

file.list <- readImmunoSeq(path = file.path)

productive.aa <- productiveSeq(file.list, aggregate = "aminoAcid")

bhattacharyyaMatrix(productive.seqs = productive.aa)
}
\seealso{
\code{\link{pairwisePlot}} for plotting results as a heat map.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/geneFreq.R
\name{geneFreq}
\alias{geneFreq}
\title{Gene frequencies}
\usage{
geneFreq(productive.nt, locus = "VDJ", family = FALSE)
}
\arguments{
\item{productive.nt}{A list of one or more data frames of productive sequences 
generated by the LymphoSeq function productiveSeq where the parameter 
aggregate is set to "nucleotide".}

\item{locus}{A character vector indicating which VDJ genes to include in the 
output.  Available options include "VDJ", "DJ", "VJ", "DJ", "V", "D", or "J".}

\item{family}{A Boolean value indicating whether or not family names instead 
of gene names are used.  If TRUE, then family names are used and if FALSE, 
gene names are used.}
}
\value{
Returns a data frame with the sample names, VDJ gene name, count, and 
\% frequency of the V, D, or J genes (each gene frequency should add to 
100\% for each sample).
}
\description{
Creates a data frame of VDJ gene counts and frequencies.
}
\examples{
file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")

file.list <- readImmunoSeq(path = file.path)

productive.nt <- productiveSeq(file.list = file.list, aggregate = "nucleotide")

geneFreq(productive.nt, locus = "VDJ", family = FALSE)

# Create a heat map of V gene usage
vfamilies <- geneFreq(productive.nt, locus = "V", family = TRUE)

require(reshape)

vfamilies <- reshape::cast(vfamilies, familyName ~ samples, value = "frequencyGene", sum)

rownames(vfamilies) <- as.character(vfamilies$familyName)

vfamilies$familyName <- NULL

RedBlue <- grDevices::colorRampPalette(rev(RColorBrewer::brewer.pal(11, "RdBu")))(256)

require(pheatmap)

pheatmap::pheatmap(vfamilies, color = RedBlue, scale = "row")

# Create a word cloud of V gene usage
vgenes <- geneFreq(productive.nt, locus = "V", family = FALSE)

require(wordcloud)

wordcloud::wordcloud(words = vgenes[vgenes$samples == "TRB_Unsorted_83", "geneName"], 
   freq = vgenes[vgenes$samples == "TRB_Unsorted_83", "frequencyGene"], 
	  colors = RedBlue)

# Create a cumulative frequency bar plot of V gene usage
vgenes <- geneFreq(productive.nt, locus = "V", family = FALSE)

require(ggplot2)

ggplot2::ggplot(vgenes, aes(x = samples, y = frequencyGene, fill = geneName)) +
  geom_bar(stat = "identity") +
  theme_minimal() + 
  scale_y_continuous(expand = c(0, 0)) + 
  guides(fill = guide_legend(ncol = 3)) +
  labs(y = "Frequency (\%)", x = "", fill = "") +
  theme(axis.text.x = element_text(angle = 90, vjust = 0.5, hjust = 1))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/lorenzCurve.R
\name{lorenzCurve}
\alias{lorenzCurve}
\title{Lorenz curve}
\usage{
lorenzCurve(samples, list)
}
\arguments{
\item{samples}{A character vector of sample names in list.}

\item{list}{A list data frames generated using the LymphoSeq function readImmunoSeq 
or productiveSeq.  "frequencyCount" is a required column.}
}
\value{
Returns a Lorenz curve.
}
\description{
Plots a Lorenz curve derived from the frequency of the amino acid sequences.
}
\details{
The Gini coefficient is an alternative metric used to calculate 
repertoire diversity and is derived from the Lorenz curve.  The Lorenz curve 
is drawn such that x-axis represents the cumulative percentage of unique 
sequences and the y-axis represents the cumulative percentage of reads.  A 
line passing through the origin with a slope of 1 reflects equal frequencies 
of all sequences.  The Gini coefficient is the ratio of the area between the 
line of equality and the observed Lorenz curve over the total area under the 
line of equality.

The plot is made using the package ggplot2 and can be reformatted
using ggplot2 functions.  See examples below.
}
\examples{
file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")

file.list <- readImmunoSeq(path = file.path)

lorenzCurve(samples = names(file.list), list = file.list)

productive.aa <- productiveSeq(file.list = file.list, aggregate = "aminoAcid")

lorenzCurve(samples = names(productive.aa), list = productive.aa)

# Change the legend labels, line colors, and add a title
samples <- c("TRB_Unsorted_0", "TRB_Unsorted_32", 
   "TRB_Unsorted_83", "TRB_Unsorted_949", "TRB_Unsorted_1320")

lorenz.curve <- lorenzCurve(samples = samples, list = productive.aa)

labels <- c("Day 0", "Day 32", "Day 83", "Day 949", "Day 1320")

colors <- c("navyblue", "red", "darkgreen", "orange", "purple")

lorenz.curve + ggplot2::scale_color_manual(name = "Samples", breaks = samples, 
   labels = labels, values = colors) + ggplot2::ggtitle("Figure Title")
}
\seealso{
An excellent resource for examples on how to reformat a ggplot can 
be found in the R Graphics Cookbook online (\url{http://www.cookbook-r.com/Graphs/}).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/removeSeq.R
\name{removeSeq}
\alias{removeSeq}
\title{Remove sequence}
\usage{
removeSeq(file.list, sequence)
}
\arguments{
\item{file.list}{A list of data frames imported using the LymphoSeq function 
readImmunoSeq.  "aminoAcid", "count", and "frequencyCount" are required columns.}

\item{sequence}{A character vector of one or more amino acid sequences to 
remove from the list of data frames.}
}
\value{
Returns a list of data frames like the one imported except all rows 
with the specified amino acid sequence are removed.  The frequencyCount is 
recalculated.
}
\description{
Removes an amino acid sequence and associated data from all instances within 
a list of data frames and then recomputes the frequencyCount.
}
\examples{
file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")

file.list <- readImmunoSeq(path = file.path)

searchSeq(list = file.list, sequence = "CASSDLIGNGKLFF")

cleansed <- removeSeq(file.list = file.list, sequence = "CASSDLIGNGKLFF")

searchSeq(list = cleansed, sequence = "CASSDLIGNGKLFF")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/seqMatrix.R
\name{seqMatrix}
\alias{seqMatrix}
\title{Sequence matrix}
\usage{
seqMatrix(productive.aa, sequences)
}
\arguments{
\item{productive.aa}{A list data frames of of productive amino acid sequences 
generated by LymphoSeq function productiveSeq where the aggregate parameter 
was set to "aminoAcid".}

\item{sequences}{A character vector of amino acid sequences of interest.  It 
is useful to specify the output from the LymphoSeq functions uniqueSeqs or 
topSeqs and subsetting the "aminoAcid" column.  See examples below.}
}
\value{
Returns a data frame of unique, productive amino acid sequences as 
rows and the \% frequency it appears in each sample as columns.
}
\description{
Creates a data frame with unique, productive amino acid sequences as rows and 
sample names as headers.  Each value in the data frame represents the 
frequency that the sequence appeared in the sample.
}
\examples{
file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")

file.list <- readImmunoSeq(path = file.path)

productive.aa <- productiveSeq(file.list = file.list, aggregate = "aminoAcid")

top.seqs <- topSeqs(productive.seqs = productive.aa, top = 0.1)

sequence.matrix <- seqMatrix(productive.aa = productive.aa, 
   sequences = top.seqs$aminoAcid)

unique.seqs <- uniqueSeqs(productive.aa = productive.aa)

sequence.matrix <- seqMatrix(productive.aa = productive.aa, 
   sequences = unique.seqs$aminoAcid)

# It can be helpful to combine top.freq and sequence.matrix
top.freq <- topFreq(productive.aa = productive.aa, percent = 0)

sequence.matrix <- seqMatrix(productive.aa = productive.aa, sequences = top.freq$aminoAcid)

top.freq.matrix <- merge(top.freq, sequence.matrix)
}
\seealso{
\code{\link{topSeqs}} and \code{\link{uniqueSeqs}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/topSeqs.R
\name{topSeqs}
\alias{topSeqs}
\title{Top sequences}
\usage{
topSeqs(productive.seqs, top = 1)
}
\arguments{
\item{productive.seqs}{A list data frames of productive sequences generated 
by the LymphoSeq function productiveSeq.  "frequencyCount" and "aminoAcid" 
are a required columns.}

\item{top}{The number of top productive sequences in each data frame to subset 
by their frequencies.}
}
\value{
Returns a data frame of a selected number of top productive sequences 
from a list of data frames.
}
\description{
Creates a data frame of a selected number of top productive sequences 
from a list of data frames.
}
\examples{
file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")

file.list <- readImmunoSeq(path = file.path)

productive.aa <- productiveSeq(file.list = file.list, aggregate = "aminoAcid")

top.seqs <- topSeqs(productive.seqs = productive.aa, top = 1)
}
\seealso{
\code{\link{chordDiagramVDJ}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/commonSeqs.R
\name{commonSeqs}
\alias{commonSeqs}
\title{Common sequences in two or more samples}
\usage{
commonSeqs(samples, productive.aa)
}
\arguments{
\item{samples}{A character vector of two or more sample names in 
productive.aa.}

\item{productive.aa}{A list of productive amino acid sequences generated
by the LymphoSeq function productiveSeq where aggregate = "aminoAcid".}
}
\value{
Returns a data frame of the common sequences between two or more files 
displaying their frequencies in each.
}
\description{
Creates a data frame of the common sequences in two or more samples, reporting 
their frequencies in each.
}
\examples{
file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")

file.list <- readImmunoSeq(path = file.path)

productive.aa <- productiveSeq(file.list = file.list, aggregate = "aminoAcid")

commonSeqs(samples = c("TRB_Unsorted_0", "TRB_Unsorted_32"), 
   productive.aa = productive.aa)
}
\seealso{
\code{\link{commonSeqsVenn}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/similarityMatrix.R
\name{similarityMatrix}
\alias{similarityMatrix}
\title{Similarity score matrix}
\usage{
similarityMatrix(productive.seqs)
}
\arguments{
\item{productive.seqs}{A list data frames of productive sequences generated 
by the LymphoSeq function productiveSeq.  "count" and "aminoAcid" 
are a required columns.}
}
\value{
A data frame of similarity scores calculated from all pairwise 
comparisons.  The similarity scores is a measure of the amount of overlap 
between two samples.  The value ranges from 0 to 1 where 1 indicates 
the sequence frequencies are identical in the two samples and 0 indicates 
no shared frequencies.
}
\description{
Calculates the similarity score of all pairwise comparison from a list of 
data frames.
}
\examples{
file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")

file.list <- readImmunoSeq(path = file.path)

productive.aa <- productiveSeq(file.list = file.list, aggregate = "aminoAcid")

similarityMatrix(productive.seqs = productive.aa)
}
\seealso{
\code{\link{pairwisePlot}} for plotting results as a heat map.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/alignSeq.R
\name{alignSeq}
\alias{alignSeq}
\title{Align mutliple sequences}
\usage{
alignSeq(list, sample = NULL, sequence = NULL, editDistance = 15,
  output = "console", type = "nucleotide", method = "ClustalOmega")
}
\arguments{
\item{list}{A list of data frames consisting of antigen receptor sequences 
imported by the LymphoSeq function readImmunoSeq.}

\item{sample}{A character vector indicating the name of the sample in the productive
sequence list.}

\item{sequence}{A character vector of one ore more amino acid or nucleotide 
CDR3 sequences to search.}

\item{editDistance}{An integer giving the minimum edit distance that the 
sequence must be less than or equal to.  See details below.}

\item{output}{A character vector indicating where the multiple sequence alignemnt should be
printed.  Options include "console" or "pdf".  If "pdf" is selected, the file is saved to
the working directory.  For "pdf" to work, Texshade must be installed.  Refer to the 
Bioconductor package msa installation instructions for more details.}

\item{type}{A character vector indicating whether "aminoAcid" or "nucleotide" sequences
should be aligned.  If "aminoAcid" is specified, then run productiveSeqs first.}

\item{method}{A character vector indicating the multiple sequence alignment method to 
be used.  Refer to the Bioconductor msa package for more details.  Options incude 
"ClustalW", "ClustalOmega", and "Muscle".}
}
\value{
Performs a multiple sequence alignemnt and prints to the console or saves a pdf to 
the working directory.
}
\description{
Perform multiple sequence alignment using one of three methods and output results to the 
console or as a pdf file.  One may perform the alignment of all amino acid or nucleotide
sequences in a single sample.  Alternatively, one may search for a given sequence 
within a list of samples using an edit distance threshold.
}
\details{
Edit distance is a way of quantifying how dissimilar two sequences 
are to one another by counting the minimum number of operations required to 
transform one sequence into the other.  For example, an edit distance of 0 
means the sequences are identical and an edit distance of 1 indicates that 
the sequences different by a single amino acid or nucleotide.
}
\examples{
file.path <- system.file("extdata", "IGH_sequencing", package = "LymphoSeq")

file.list <- readImmunoSeq(path = file.path)

productive.nt <- productiveSeq(file.list = file.list, aggregate = "nucleotide")

alignSeq(list = productive.nt, sample = "IGH_MVQ92552A_BL", type = "nucleotide", 
         method = "ClustalW", output = "console")
}
\seealso{
If having trouble saving pdf files, refer to Biconductor package msa for
installation instructions
\url{http://bioconductor.org/packages/release/bioc/vignettes/msa/inst/doc/msa.pdf}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/searchSeq.R
\name{searchSeq}
\alias{searchSeq}
\title{Search for a sequence}
\usage{
searchSeq(list, sequence, type = "aminoAcid", match = "global",
  editDistance = 0)
}
\arguments{
\item{list}{A list of data frames generated by the LymphoSeq functions readImmunoSeq 
or productiveSeq.  "aminoAcid" or "nucleotide", "frequencyCount", and 
"count" are required columns.}

\item{sequence}{A character vector of one ore more amino acid or nucleotide 
CDR3 sequences to search.}

\item{type}{A character vector specifying the type of sequence(s) to be 
searched.  Available options are "aminoAcid" or "nucleotide".}

\item{match}{A character vector specifying whether an exact partial or exact global
 match of the searched sequence(s) is desired.  Available options are 
"partial" and "global".}

\item{editDistance}{An integer giving the minimum edit distance that the 
sequence must be less than or equal to.  See details below.}
}
\value{
Returns the rows for every instance in the list of data frames where 
the searched sequence(s) appeared.
}
\description{
Search for one or more amino acid or nucleotide CDR3 sequences in a list of 
data frames.
}
\details{
An exact partial match means the searched sequence is contained within 
target sequence.  An exact global match means the searched sequence is identical to 
the target sequence.

Edit distance is a way of quantifying how dissimilar two sequences 
are to one another by counting the minimum number of operations required to 
transform one sequence into the other.  For example, an edit distance of 0 
means the sequences are identical and an edit distance of 1 indicates that 
the sequences different by a single amino acid or nucleotide.
}
\examples{
file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")

file.list <- readImmunoSeq(path = file.path)

aa1 <- "CASSPVSNEQFF"

aa2 <- "CASSQEVPPYQAFF"

searchSeq(list = file.list, sequence = aa1, type = "aminoAcid", 
   match = "global", editDistance = 0)

searchSeq(list = file.list, sequence = c(aa1, aa2), 
   type = "aminoAcid", match = "global", editDistance = 0)

searchSeq(list = file.list, sequence = aa1, type = "aminoAcid", editDistance = 1)

nt <- "CTGATTCTGGAGTCCGCCAGCACCAACCAGACATCTATGTACCTCTGTGCCAGCAGTCCGGTAAGCAATGAGCAGTTCTTCGGGCCA"

searchSeq(list = file.list, sequence = nt, type = "nucleotide", editDistance = 3)

searchSeq(list = file.list, sequence = "CASSPVS", type = "aminoAcid", 
   match = "partial", editDistance = 0)

searchSeq(list = file.list, sequence = nt, type = "nucleotide", editDistance = 0)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cloneTrack.R
\name{cloneTrack}
\alias{cloneTrack}
\title{Clone tracking plot}
\usage{
cloneTrack(sequence.matrix, map = "none", productive.aa, label = "none",
  track = "none", unassigned = TRUE)
}
\arguments{
\item{sequence.matrix}{A sequence matrix generated from the LymphoSeq 
function seqMatrix.}

\item{map}{An optional character vector of one or more sample names contained 
in the productive.aa list.  If the same sequence appears in multiple mapped 
samples, then it will be assigned the label of the first listed sample only.}

\item{productive.aa}{A list of data frames of productive amino acid sequences 
containing the samples to be mapped.  This parameter is only required if 
sequence mapping is performed.}

\item{label}{An optional character vector of one or more labels used to 
annotate the mapped sequences.  The order of the labels must match the order 
of the samples listed in map.}

\item{track}{An optional character vector of one or more amino acid sequences 
to track.}

\item{unassigned}{A Boolean value indicating whether or not to draw the lines 
of sequences not being mapped or tracked.  If TRUE then the unassigned 
sequences are drawn.  If FALSE, then the unassigned sequences are not drawn.}
}
\value{
Returns a line plot showing the amino acid frequencies across 
multiple samples in the sequence matrix where each line represents one 
unique sequence.
}
\description{
Creates line plot tracking amino acid frequencies across multiple samples
}
\details{
The plot is made using the package ggplot2 and can be reformatted
using ggplot2 functions.  See examples below.
}
\examples{
file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")

file.list <- readImmunoSeq(path = file.path)

productive.aa <- productiveSeq(file.list = file.list, aggregate = "aminoAcid")

top.freq <- topFreq(productive.aa = productive.aa, percent = 0.1)

sequence.matrix <- seqMatrix(productive.aa = productive.aa, sequences = top.freq$aminoAcid)

# Track clones without mapping or tracking specific sequences
cloneTrack(sequence.matrix = sequence.matrix)

# Track top 20 clones mapping to the CD4 and CD8 samples
cloneTrack(sequence.matrix = sequence.matrix, productive.aa = productive.aa, 
   map = c("TRB_CD4_949", "TRB_CD8_949"), label = c("CD4", "CD8"), 
   track = top.freq$aminoAcid[1:20], unassigned = TRUE) 

# Track the top 10 clones from top.freq
cloneTrack(sequence.matrix = sequence.matrix, productive.aa = productive.aa, 
   track = top.freq$aminoAcid[1:10], unassigned = FALSE) 

# Track clones mapping to the CD4 and CD8 samples while ignoring all others
cloneTrack(sequence.matrix = sequence.matrix, productive.aa = productive.aa, 
   map = c("TRB_CD4_949", "TRB_CD8_949"), label = c("CD4", "CD8"), 
   unassigned = FALSE) 

# Track clones mapping to the CD4 and CD8 samples and track 2 specific sequences
cloneTrack(sequence.matrix = sequence.matrix, productive.aa = productive.aa, 
   map = c("TRB_CD4_949", "TRB_CD8_949"), label = c("CD4", "CD8"), 
   track = c("CASSPPTGERDTQYF", "CASSQDRTGQYGYTF"), unassigned = FALSE)

# Reorder the x axis, change the axis labels, convert to log scale, and add title
x.limits <- c("TRB_Unsorted_0", "TRB_Unsorted_32", 
   "TRB_Unsorted_83", "TRB_Unsorted_949", "TRB_Unsorted_1320")

sequence.matrix <- sequence.matrix[ ,c("aminoAcid", x.limits)]
   
clone.track <- cloneTrack(sequence.matrix = sequence.matrix, 
   productive.aa = productive.aa, track = top.freq$aminoAcid[1:10], unassigned = FALSE) 

x.labels <- c("Day 0", "Day 32", "Day 83", "Day 949", "Day 1320")

clone.track + 
   ggplot2::scale_x_discrete(expand = c(0,0), labels = x.labels) + 
   ggplot2::scale_y_log10() + ggplot2::annotation_logticks(sides = "l") + 
   ggplot2::ggtitle("Figure Title")
}
\seealso{
An excellent resource for examples on how to reformat a ggplot can 
be found in the R Graphics Cookbook online (\url{http://www.cookbook-r.com/Graphs/}).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readImmunoSeq.R
\name{readImmunoSeq}
\alias{readImmunoSeq}
\title{Read ImmunoSeq files}
\usage{
readImmunoSeq(path, columns = c("aminoAcid", "nucleotide", "count",
  "count (templates)", "count (reads)", "count (templates/reads)",
  "frequencyCount", "frequencyCount (\%)", "estimatedNumberGenomes",
  "vFamilyName", "dFamilyName", "jFamilyName", "vGeneName", "dGeneName",
  "jGeneName"), recursive = FALSE)
}
\arguments{
\item{path}{Path to the directory containing tab-delimited files.  Only 
files with the extension .tsv are imported.  The names of the data frames are 
the same as names of the files.}

\item{columns}{Column names from the tab-delimited files that you desire to 
import, all others will be disregarded.  May use "all" to import all columns.  
A warning may be called if columns contain no data or must be coereced to a 
different class.  Usually this warning can be ignored.}

\item{recursive}{A Boolean value indicating whether tab-delimited files in 
subdirectories should be imported.  If TRUE, then all files in the parent as 
well as the subdirectory are imported.  If FALSE, then only files in the 
parent directory are imported.}
}
\value{
Returns a list of data frames.  The names of each data frame are
assigned according to the original ImmunoSEQ file names.
}
\description{
Imports tab-separated value (.tsv) files exported by the Adaptive 
Biotechnologies ImmunoSEQ analyzer and stores them as a list of data frames.
}
\details{
May import tab-delimited files containing antigen receptor 
sequencing from other sources (e.g. miTCR or miXCR) as long as the column 
names are the same as used by ImmunoSEQ files.  Available column headings in 
ImmunoSEQ files are:  
"nucleotide", "aminoAcid", "count", "count (templates)", "count (reads)", 
"count (templates/reads)", "frequencyCount", "frequencyCount (\%)", "cdr3Length", 
"vMaxResolved", "vFamilyName", "vGeneName", "vGeneAllele", "vFamilyTies", 
"vGeneNameTies", "vGeneAlleleTies", "dMaxResolved", "dFamilyName", "dGeneName", 
"dGeneAllele", "dFamilyTies", "dGeneNameTies", "dGeneAlleleTies", "jMaxResolved", 
"jFamilyName", "jGeneName", "jGeneAllele", "jFamilyTies", "jGeneNameTies", 
"jGeneAlleleTies", "vDeletion", "d5Deletion", "d3Deletion", "jDeletion", 
"n2Insertion", "n1Insertion", "vIndex", "n2Index", "dIndex", "n1Index", 
"jIndex", "estimatedNumberGenomes", "sequenceStatus", "cloneResolved", 
"vOrphon", "dOrphon", "jOrphon", "vFunction", "dFunction", "jFunction", 
"fractionNucleated".  
 
IMPORTANT: be aware that Adaptive has changed the 
column names of their files over time and if the headings of your files are 
inconsistent, then specify column = "all" or include all variations of the 
headings you want to important.  For example, column = c("count", 
"count (templates)", "count (reads)").  Also be aware that the "count" 
column previously reported the number of sequencing reads in earlier 
versions of ImmunoSEQ but now is equivalent to the 
"estimatedNumberGenomes" column.
}
\examples{
file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")

file.list <- readImmunoSeq(path = file.path, 
                           columns = c("aminoAcid", "nucleotide", "count", 
                                     "count (templates)", "count (reads)", 
                                     "count (templates/reads)",
                                     "frequencyCount", "frequencyCount (\%)", 
                                     "estimatedNumberGenomes"), 
                           recursive = FALSE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/differentialAbundance.R
\name{differentialAbundance}
\alias{differentialAbundance}
\title{Differential abundance analysis}
\usage{
differentialAbundance(sample1, sample2, list,
  abundance = "estimatedNumberGenomes", type = "aminoAcid", q = 1,
  zero = 0.001, parallel = FALSE)
}
\arguments{
\item{sample1}{A character vector indicating the name of the first sample in the list
to be compared.}

\item{sample2}{A character vector indicating the name of the second sample in the list
to be compared.}

\item{list}{A list of data frames consisting of antigen receptor sequences 
imported by the LymphoSeq function readImmunoSeq.}

\item{abundance}{The input value for the Fisher exact test.  "estimatedNumberGenomes"
is recommend but "count" may also be used.}

\item{type}{A character vector indicating whether "aminoAcid" or "nucleotide" sequences
should be used.  If "aminoAcid" is specified, then run productiveSeqs first.}

\item{q}{A numeric value between 0.0 and 1.0 indicating the threshold Holms adjusted 
P value (also knowns as the false discovery rate or q value) to subset the results with.  
Any sequences with a q value greater than this value will not be shown.}

\item{zero}{A numeric value to set all zero values to when calculating the log2
transformed fold change between samples 1 and 2.  This does not apply to the 
p and q value calculations.}

\item{parallel}{A boolean indicating wheter parallel processing should be used or not.}
}
\value{
Returns a data frame with columns corresponding to the frequency of the abudance
measure in samples 1 and 2, the P value, Q value (Holms adjusted P value, also knowns as 
the false discovery rate), and log2 transformed fold change.
}
\description{
Use a Fisher exact test to calculate differential abdunance of each sequence in 
two samples and reports the log2 transformed fold change, P value and adjusted P value.
}
\examples{
file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")

file.list <- readImmunoSeq(path = file.path)

productive.aa <- productiveSeq(file.list = file.list, aggregate = "aminoAcid")

differentialAbundance(list = productive.aa, sample1 = "TRB_Unsorted_949", 
                      sample2 = "TRB_Unsorted_1320", type = "aminoAcid", q = 0.01, 
                      zero = 0.001)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/commonSeqsPlot.R
\name{commonSeqsPlot}
\alias{commonSeqsPlot}
\title{Common sequences plot}
\usage{
commonSeqsPlot(sample1, sample2, productive.aa, show = "common")
}
\arguments{
\item{sample1}{A name of a sample in a list of data frames generated by the 
LymphoSeq function productiveSeq.}

\item{sample2}{A name of a sample in a list of data frames generated by the 
LymphoSeq function productiveSeq.}

\item{productive.aa}{A list of data frames of productive amino acid sequences 
produced by the LymphoSeq function productiveSeq containing the 
samples to be compared.}

\item{show}{A character vector specifying whether only the common sequences 
should be shown or all sequences.  Available options are "common" or "all".}
}
\value{
Returns a frequency scatter plot of two samples showing only the 
shared sequences.
}
\description{
Creates a scatter plot of just the sequences in common between two samples.
}
\details{
The plot is made using the package ggplot2 and can be reformatted
using ggplot2 functions.  See examples below.
}
\examples{
file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")

file.list <- readImmunoSeq(path = file.path)

productive.aa <- productiveSeq(file.list = file.list, aggregate = "aminoAcid")

commonSeqsPlot("TRB_Unsorted_32", "TRB_Unsorted_83", 
   productive.aa = productive.aa)

# Change the X and Y axises to log-10 scale
commonSeqsPlot("TRB_Unsorted_32", "TRB_Unsorted_83", 
   productive.aa = productive.aa) +
   ggplot2::scale_x_log10() + 
   ggplot2::scale_y_log10() + 
   ggplot2::annotation_logticks(sides = "bl")
}
\seealso{
An excellent resource for examples on how to reformat a ggplot can 
be found in the R Graphics Cookbook online (\url{http://www.cookbook-r.com/Graphs/}).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/similarityScore.R
\name{similarityScore}
\alias{similarityScore}
\title{Similarity score}
\usage{
similarityScore(sample1, sample2)
}
\arguments{
\item{sample1}{A data frame consisting of frequencies of antigen receptor 
sequences.  "aminoAcid" and "count" are a required columns.}

\item{sample2}{A data frame consisting of frequencies of antigen receptor 
sequences.  "aminoAcid" and "count" are a required columns.}
}
\value{
Returns the similarity score, a measure of the amount of 
overlap between two samples.  The value ranges from 0 to 1 where 1 indicates 
the sequence frequencies are identical in the two samples and 0 
indicates no shared frequencies.
}
\description{
Calculates the similarity score of two samples.
}
\examples{
file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")

file.list <- readImmunoSeq(path = file.path)

productive.aa <- productiveSeq(file.list, aggregate = "aminoAcid")

similarityScore(productive.aa[["TRB_Unsorted_32"]], productive.aa[["TRB_Unsorted_83"]])
}
\seealso{
\code{\link{similarityMatrix}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/topFreq.R
\name{topFreq}
\alias{topFreq}
\title{Top frequencies}
\usage{
topFreq(productive.aa, percent = 0.1)
}
\arguments{
\item{productive.aa}{A list data frames of of productive amino acid sequences 
imported using the function LymphoSeq function productiveSeq where the 
aggregate parameter was set to "aminoAcid".}

\item{percent}{The minimum \% frequency that the sequence appears in any of 
the listed samples.}
}
\value{
A data frame of amino acid sequences and the number of samples that 
the sequence appears in along with the minimum, maximum, and mean frequency 
across all samples.  
For T cell receptor beta sequences, additionally reported is the 
\% prevalence that the sequence appears in 55 healthy donor blood samples.  
Also provided is the antigen specificity of that sequence if known by 
comparing it to a database of previously reported sequences in the 
literature.  The prevalenceTRB and publishedTRB databases are located in a 
separate package called LymphoSeqDB that should be loaded automatically.
}
\description{
Creates a data frame of the top productive amino acid sequences that have a 
specified minimum frequency threshold and reports the number of samples that 
the sequence appears in along with the minimum, maximum, and mean frequency 
across all samples.  For T cell receptor beta sequences, the \% prevalence 
and antigen specificity of that sequence is also provided.
}
\examples{
file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")

file.list <- readImmunoSeq(path = file.path)

productive.aa <- productiveSeq(file.list = file.list, aggregate = "aminoAcid")

top.freq <- topFreq(productive.aa = productive.aa, percent = 0.1)
}
\seealso{
Refer to the LymphoSeqDB package for details regarding the 
prevalenceTRB and publishedTRB database.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/clonalRelatedness.R
\name{clonalRelatedness}
\alias{clonalRelatedness}
\title{Clonal relatedness}
\usage{
clonalRelatedness(list, editDistance = 10)
}
\arguments{
\item{list}{A list data frames of unproductive or productive nucleotide 
sequences or productive nucleotide sequences.  Nucleotide and count are 
required columns.}

\item{editDistance}{An integer giving the minimum edit distance that the 
sequence must be less than or equal to. See details below.}
}
\value{
Returns a data frame with the calculated clonal relatedness for each sample.
}
\description{
Calculates the clonal relatedness for each sample in a list of data frames.
}
\details{
Clonal relatedness is the proportion of nucleotide sequences that
are related by a defined edit distance threshold.  The value ranges from 0 to
1 where 0 indicates no sequences are related and 1 indicates all sequences 
are related.

Edit distance is a way of quantifying how dissimilar two sequences 
are to one another by counting the minimum number of operations required to 
transform one sequence into the other. For example, an edit distance of 0 
means the sequences are identical and an edit distance of 1 indicates that 
the sequences different by a single amino acid or nucleotide.
}
\examples{
file.path <- system.file("extdata", "IGH_sequencing", package = "LymphoSeq")

file.list <- readImmunoSeq(path = file.path)

clonal.relatedness <- clonalRelatedness(list = file.list, editDistance = 10)

# Merge results with clonality table
clonality <- clonality(file.list = file.list)
merged <- merge(clonality, clonal.relatedness)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/clonality.R
\name{clonality}
\alias{clonality}
\title{Clonality}
\usage{
clonality(file.list)
}
\arguments{
\item{file.list}{A list of data frames consisting of antigen receptor 
sequencing imported by the LymphoSeq function readImmunoSeq. "aminoAcid", "count", 
and "frequencyCount" are required columns.  "estimatedNumberGenomes" is optional.  
Note that clonality is usually calculated from productive nucleotide sequences.  
Therefore, it is not recommended to run this function using a productive sequence
list aggregated by amino acids.}
}
\value{
Returns a data frame giving the total number of sequences, number of 
unique productive sequences, number of genomes, clonality, Gini coefficient, 
and the frequency (\%) of the top productive sequence in each sample.
}
\description{
Creates a data frame giving the total number of sequences, number of unique 
productive sequences, number of genomes, entropy, clonality, Gini 
coefficient, and the frequency (\%) of the top productive sequences in a list 
of sample data frames.
}
\details{
Clonality is derived from the Shannon entropy, which is calculated 
from the frequencies of all productive sequences divided by the logarithm of 
the total number of unique productive sequences.  This normalized entropy 
value is then inverted (1 - normalized entropy) to produce the clonality 
metric.  

The Gini coefficient is an alternative metric used to calculate repertoire 
diversity and is derived from the Lorenz curve.  The Lorenz curve is drawn 
such that x-axis represents the cumulative percentage of unique sequences and 
the y-axis represents the cumulative percentage of reads.  A line passing 
through the origin with a slope of 1 reflects equal frequencies of all clones.  
The Gini coefficient is the ratio of the area between the line of equality 
and the observed Lorenz curve over the total area under the line of equality.  
Both Gini coefficient and clonality are reported on a scale from 0 to 1 where 
0 indicates all sequences have the same frequency and 1 indicates the 
repertoire is dominated by a single sequence.
}
\examples{
file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")

file.list <- readImmunoSeq(path = file.path)

clonality(file.list = file.list)
}
\seealso{
\code{\link{lorenzCurve}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/productiveSeq.R
\name{productiveSeq}
\alias{productiveSeq}
\title{Productive sequences}
\usage{
productiveSeq(file.list, aggregate = "aminoAcid", prevalence = FALSE)
}
\arguments{
\item{file.list}{A list of data frames consisting antigen receptor sequencing 
data imported by the LymphoSeq function readImmunoSeq. "aminoAcid", "count", and 
"frequencyCount" are required columns.}

\item{aggregate}{Indicates whether the values of "count", "frequencyCount", 
and "esimatedNumberGenomes" should be aggregated by amino acid or nucleotide 
sequence.  Acceptable values are "aminoAcid" or "nucleotide".  If "aminoAcid" 
is selected, then resulting data frame will have columns corresponding to 
aminoAcid, count, frequencyCount, and estimatedNumberGenomes (if this 
column is available).  If "nucleotide" is selected then all columns in the 
original list will be present in the outputted list.  The difference in 
output is due to the fact that the same amino acid CDR3 sequence may be 
encoded by multiple unique nucleotide sequences with differing V, D, and J 
genes.}

\item{prevalence}{A Boolean value indicating if a new column should be added 
to each of the data frames giving the prevalence of each CDR3 amino acid 
sequence in 55 healthy donor peripheral blood samples.  TRUE means the column 
is added and FALSE means it is not.  Values range from 0 to 100\% where 
100\% means the sequence appeared in the blood of all 55 individuals.  The 
prevalenceTRB database is located in a separate package called LymphoSeqDB 
that should be loaded automatically.}
}
\value{
Returns a list of data frames of productive amino acid sequences with
recomputed values for "count", "frequencyCount", and 
"esimatedNumberGenomes".  A productive sequences is defined as a sequences 
that is in frame and does not have an early stop codon.
}
\description{
Remove unproductive CDR3 sequences from a list of data frames.
}
\examples{
file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")

file.list <- readImmunoSeq(path = file.path)

productive.nt <- productiveSeq(file.list = file.list, 
   aggregate = "nucleotide", prevalence = FALSE)

productive.aa <- productiveSeq(file.list = file.list, 
  aggregate = "aminoAcid", prevalence = TRUE)
}
\seealso{
Refer to the LymphoSeqDB package for details regarding the 
prevalenceTRB database.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/commonSeqsVenn.R
\name{commonSeqsVenn}
\alias{commonSeqsVenn}
\title{Common sequences Venn diagram}
\usage{
commonSeqsVenn(samples, productive.seqs)
}
\arguments{
\item{samples}{A character vector of two or three names of samples in 
productive.seqs to compare.}

\item{productive.seqs}{A list of productive amino acid sequences generated
by the LymphoSeq function productiveSeq.}
}
\value{
Returns a a Venn diagram of the number of common sequences between
two or three samples.
}
\description{
Creates a Venn diagram comparing the number of common sequences in two or 
three samples.
}
\examples{
file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")

file.list <- readImmunoSeq(path = file.path)

productive.aa <- productiveSeq(file.list = file.list, aggregate = "aminoAcid")

# Plot a triple Venn diagram
commonSeqsVenn(samples = c("TRB_Unsorted_0", 
   "TRB_Unsorted_32", "TRB_Unsorted_83"), 
   productive.seqs = productive.aa)

# Plot a double Venn diagram
commonSeqsVenn(samples = c("TRB_Unsorted_0", 
   "TRB_Unsorted_32"), productive.seqs = productive.aa)

# Save Venn diagram as a .png file to working directory
png(filename = "Venn diagram.png", res = 300, units = "in", height = 5, width = 5)

commonSeqsVenn(samples = c("TRB_Unsorted_0", "TRB_Unsorted_32"), 
   productive.seqs = productive.aa)

dev.off()
}
\seealso{
\code{\link{commonSeqs}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/searchPublished.R
\name{searchPublished}
\alias{searchPublished}
\title{Search for T cell receptor beta CDR3 amino acid sequences with known antigen 
specificity}
\usage{
searchPublished(list)
}
\arguments{
\item{list}{A list of data frames generated by the LymphoSeq functions 
readImmunoSeq or productiveSeq.  "aminoAcid", "frequencyCount", and "count" 
are required columns.}
}
\value{
Returns a data frame of each sample name and instance in the sample 
that the published TCR sequence appeared along with additional 
information including antigen specificity, epitope, HLA type, and PubMed ID 
(PMID) for the reference where the sequence was characterized.  The 
publishedTRB database is located in a separate package called LymphoSeqDB 
that should be loaded automatically.
}
\description{
Search for published T cell receptor beta CDR3 amino acid sequences with 
known antigen specificity in a list of data frames.
}
\examples{
file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")

file.list <- readImmunoSeq(path = file.path)

productive.aa <- productiveSeq(file.list = file.list, aggregate = "aminoAcid")

searchPublished(list = productive.aa)
}
\seealso{
Refer to the LymphoSeqDB package for details regarding the 
publishedTRB database.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mergeFiles.R
\name{mergeFiles}
\alias{mergeFiles}
\title{Merge files}
\usage{
mergeFiles(samples, file.list)
}
\arguments{
\item{samples}{A character vector of the names of the samples that are to be 
merged in file.list.}

\item{file.list}{A list of data frames imported using the LymphoSeq function
readImmunoSeq that contain the sample names that are to be merged.  "aminoAcid", 
"nucleotide", "count" and "frequencyCount" are required columns.}
}
\value{
Returns a data frame of the merged samples.  The values of count, 
frequencyCount, and estimatedNumberGenomes are aggregated.  That is, the sum 
of count and estimatedNumberGenomes columns of the merged data frame should 
equal the sum of the columns from the unmerged samples.  Likewise, the 
frequencyCount of the merged data frame should add up to 100\%.  All other 
columns in the unmerged data frames are included in the merge data frame.
}
\description{
Merges two or more sample data frames into a single data frame and aggregates 
count, frequencyCount, and estimatedNumberGenomes.
}
\examples{
file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")

file.list <- readImmunoSeq(path = file.path)

TCRB_Day949_Merged <- mergeFiles(samples = c("TRB_CD4_949", 
   "TRB_CD8_949"), file.list)

# To combine the merged data frames with file.list
file.list <- c(list("TCRB_Day949_Merged" = TCRB_Day949_Merged), file.list)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/exportFasta.R
\name{exportFasta}
\alias{exportFasta}
\title{Export sequences in fasta format}
\usage{
exportFasta(list, type = "nucleotide", names = c("rank", "aminoAcid",
  "count"))
}
\arguments{
\item{list}{A list of data frames consisting of antigen receptor sequences 
imported by the LymphoSeq function readImmunoSeq.}

\item{type}{A character vector indicating whether "aminoAcid" or "nucleotide" sequences
should be exported.  If "aminoAcid" is specified, then run productiveSeqs first.}

\item{names}{A character vector of one or more column names to name the sequences.
If "rank" is specified, then the rank order of the sequences by frequency is used.}
}
\value{
Exports fasta files to the working directory.
}
\description{
Export nucleotide or amino acid sequences in fasta format.
}
\examples{
file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")

file.list <- readImmunoSeq(path = file.path)

exportFasta(list = file.list, type = "nucleotide", names = c("rank", "aminoAcid", "count"))

productive.aa <- productiveSeq(file.list = file.list, aggregate = "aminoAcid")

exportFasta(list = productive.aa, type = "aminoAcid", names = "frequencyCount")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/topSeqsPlot.R
\name{topSeqsPlot}
\alias{topSeqsPlot}
\title{Cumulative frequency bar plot of top sequences}
\usage{
topSeqsPlot(list, top = 10)
}
\arguments{
\item{list}{A list data frames imported using the LymphoSeq function readImmunoSeq 
or productiveSeq.}

\item{top}{The number of top sequences to be colored in the bar plot.  All 
other, less frequent sequences are colored violet.}
}
\value{
Returns a cumulative frequency bar plot of the top sequences.
}
\description{
Create a cumulative frequency bar plot of a specified number of top 
sequences.
}
\details{
The plot is made using the package ggplot2 and can be reformatted
using ggplot2 functions.  See examples below.
}
\examples{
file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")

file.list <- readImmunoSeq(path = file.path)

topSeqsPlot(list = file.list, top = 10)

# Display the number of sequences at the top of bar plot and add a title
n <- as.character(lapply(file.list, nrow))

topSeqsPlot(list = file.list, top = 10) + 
   ggplot2::annotate("text", x = 1:length(file.list), y = 105, label = n, color = "black") +
   ggplot2::expand_limits(y = c(0, 110)) + ggplot2::ggtitle("Figure Title") + 
   ggplot2::scale_x_discrete(limits = names(file.list))
}
\seealso{
An excellent resource for examples on how to reformat a ggplot can 
be found in the R Graphics Cookbook online (\url{http://www.cookbook-r.com/Graphs/}).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/uniqueSeqs.R
\name{uniqueSeqs}
\alias{uniqueSeqs}
\title{Unique sequences}
\usage{
uniqueSeqs(productive.aa)
}
\arguments{
\item{productive.aa}{A list data frames of of productive amino acid sequences 
imported using the function LymphoSeq function productiveSeq where the 
aggregate parameter was set to "aminoAcid".}
}
\value{
A data frame of unique amino acid sequences from the list of 
data frames aggregated by count.
}
\description{
Aggregates all productive sequences within a list of data frames by count.
}
\examples{
file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")

file.list <- readImmunoSeq(path = file.path)

productive.aa <- productiveSeq(file.list = file.list, aggregate = "aminoAcid")

unique.seqs <- uniqueSeqs(productive.aa = productive.aa)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/phyloTree.R
\name{phyloTree}
\alias{phyloTree}
\title{Create phylogenetic tree}
\usage{
phyloTree(list, sample, type = "nucleotide", layout = "rectangular",
  label = TRUE)
}
\arguments{
\item{list}{A list data frames of unproductive nucleotide sequences or productive 
nucleotide sequences generated by the LymphoSeq function productiveSeq.  
vFamilyName, dFamilyName, jFamilyName, and count are required columns.}

\item{sample}{A character vector indicating the name of the sample in the productive
sequence list.}

\item{type}{A character vector indicating whether "aminoAcid" or "nucleotide" sequences
should be compared.}

\item{layout}{A character vector indicating the tree layout.  Options include 
"rectangular", "slanted", "fan", "circular", "radial" and "unrooted".}

\item{label}{A Boolean indicating if the sequencing count should be shown next to the leaves.}
}
\value{
Returns a phylogenetic tree where each leaf represents a sequence color coded by the
V, D, and J gene usage.  The number next to each leaf refers to the sequence count.  A triangle 
shaped leaf indicates the dominant sequence.  Refer to the ggtree Bioconductor package 
documentation for details on how to manipulate the tree.
}
\description{
Create a phylogenetic tree using neighbor joining tree estimation for amino acid or 
nucleotide CDR3 sequences in a list of data frames.
}
\examples{
file.path <- system.file("extdata", "IGH_sequencing", package = "LymphoSeq")

file.list <- readImmunoSeq(path = file.path)

productive.nt <- productiveSeq(file.list = file.list, aggregate = "nucleotide")

phyloTree(list = productive.nt, sample = "IGH_MVQ92552A_BL", type = "nucleotide", 
         layout = "rectangular")

phyloTree(list = productive.nt, sample = "IGH_MVQ92552A_BL", type = "aminoAcid", 
         layout = "circular")
         
# Add scale and title to figure
library(ggtree)
library(ggplot2)
phyloTree(list = productive.nt, sample = "IGH_MVQ92552A_BL", type = "aminoAcid", 
         layout = "rectangular") +
         ggtree::theme_tree2() +
         ggplot2::theme(legend.position = "right", legend.key = element_rect(colour = "white")) +
         ggplot2::ggtitle("Title")
         
# Hide legend and leaf labels
phyloTree(list = productive.nt, sample = "IGH_MVQ92552A_BL", type = "nucleotide", 
         layout = "rectangular", label = FALSE) +
         ggplot2::theme(legend.position="none")
         
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pairwisePlot.R
\name{pairwisePlot}
\alias{pairwisePlot}
\title{Pairwise comparison plot}
\usage{
pairwisePlot(matrix)
}
\arguments{
\item{matrix}{A similarity or Bhattacharyya matrix produced by the LymphoSeq 
functions similarityMatrix or bhattacharyyaMatrix.}
}
\value{
A pairwise comparison heat map.
}
\description{
Creates a heat map from a similarity or Bhattacharyya matrix.
}
\details{
The plot is made using the package ggplot2 and can be reformatted
using ggplot2 functions.  See examples below.
}
\examples{
file.path <- system.file("extdata", "TCRB_sequencing", package = "LymphoSeq")

file.list <- readImmunoSeq(path = file.path)

productive.aa <- productiveSeq(file.list = file.list, aggregate = "aminoAcid")

similarity.matrix <- similarityMatrix(productive.seqs = productive.aa)

pairwisePlot(matrix = similarity.matrix)

bhattacharyya.matrix <- bhattacharyyaMatrix(productive.seqs = productive.aa)

pairwisePlot(matrix = bhattacharyya.matrix)

# Change plot color, title legend, and add title
pairwisePlot(matrix = similarity.matrix) + 
   ggplot2::scale_fill_gradient(low = "#deebf7", high = "#3182bd") + 
   ggplot2::labs(fill = "Similarity score") + ggplot2::ggtitle("Figure Title")
}
\seealso{
An excellent resource for examples on how to reformat a ggplot can 
be found in the R Graphics Cookbook online (\url{http://www.cookbook-r.com/Graphs/}).
The functions to create the similarity or Bhattacharyya matrix can be found 
here: \code{\link{similarityMatrix}} and \code{\link{bhattacharyyaMatrix}}
}
